"use strict";
(self["webpackChunk_amphi_pipeline_components_core"] = self["webpackChunk_amphi_pipeline_components_core"] || []).push([["lib_index_js"],{

/***/ "./lib/components/Aggregate.js":
/*!*************************************!*\
  !*** ./lib/components/Aggregate.js ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Aggregate: () => (/* binding */ Aggregate)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;



 // Assuming aggregateIcon is available
class Aggregate extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Aggregate";
        this._id = "aggregate";
        this._type = "pandas_df_processor";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.aggregateIcon;
        this._category = "transform";
        this._default = {};
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "columns",
                    label: "Group by",
                    id: "groupByColumns",
                    placeholder: "Select columns"
                },
                {
                    type: "keyvalueColumnsSelect",
                    label: "Operations",
                    id: "columnsOperations",
                    placeholder: "Select column",
                    options: [
                        { value: "min", label: "Min" },
                        { value: "max", label: "Max" },
                        { value: "sum", label: "Sum" },
                        { value: "count", label: "Count" },
                        { value: "mean", label: "Mean" }
                    ],
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: Aggregate.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: Aggregate.Name,
            ConfigForm: Aggregate.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: Aggregate.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, inputName, outputName }) {
        const groupColumns = config.groupByColumns.map(col => col.value);
        // Start constructing the aggregation arguments dynamically
        let aggArgs = "";
        if (config.columnsOperations && config.columnsOperations.length > 0) {
            config.columnsOperations.forEach((op, index) => {
                // Determine how to reference the column based on 'named'
                const columnReference = op.key.named ? `'${op.key.value}'` : op.key.value;
                const operation = op.value.value;
                const columnName = op.key.named ? op.key.value : `col${op.key.value}`;
                const operationName = `${columnName}_${operation}`;
                // Construct each aggregation argument
                aggArgs += `${operationName}=(${columnReference}, '${operation}')`;
                if (index < config.columnsOperations.length - 1) {
                    aggArgs += ", ";
                }
            });
        }
        // Generate groupby code
        let code = `
${outputName} = ${inputName}.groupby([`;
        // Add group columns
        groupColumns.forEach(col => {
            code += `"${col}",`;
        });
        // Complete the aggregation function call
        code += `]).agg(${aggArgs}).reset_index()\n`;
        return code;
    }
}
_a = Aggregate;
Aggregate.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/Console.js":
/*!***********************************!*\
  !*** ./lib/components/Console.js ***!
  \***********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Console: () => (/* binding */ Console)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class Console extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Console";
        this._id = "console";
        this._type = "pandas_df_output";
        this._category = "output";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.monitorIcon;
        this._default = {};
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "inputNumber",
                    label: "Records limit",
                    id: "limit",
                    placeholder: "Number of records to print in console",
                    min: 0
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderHandle, {
            type: Console.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_1__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_1__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: Console.Name,
            ConfigForm: Console.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: Console.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, inputName }) {
        if (config.limit) {
            inputName += `.head(${config.limit})`;
        }
        const code = `
print(${inputName})
`;
        return code;
    }
}
_a = Console;
Console.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/CsvFileInput.js":
/*!****************************************!*\
  !*** ./lib/components/CsvFileInput.js ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CsvFileInput: () => (/* binding */ CsvFileInput)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class CsvFileInput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "CSV File Input";
        this._id = "csvFileInput";
        this._type = "pandas_df_input";
        this._fileDrop = ["csv", "tsv"];
        this._category = "input";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.fileTextIcon;
        this._default = { csvOptions: { sep: "," } };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "file",
                    label: "File path",
                    id: "filePath",
                    placeholder: "Type file name",
                    tooltip: "This field expects a file path with a csv, tsv or txt extension such as input.csv.",
                    validation: "\\.(csv|tsv|txt)$",
                },
                {
                    type: "selectCustomizable",
                    label: "Separator",
                    id: "csvOptions.sep",
                    placeholder: "default: ,",
                    tooltip: "Select or provide a custom deilimiter.",
                    options: [
                        { value: ",", label: "comma (,)" },
                        { value: ";", label: "semicolon (;)" },
                        { value: " ", label: "space" },
                        { value: "  ", label: "tab" },
                        { value: "|", label: "pipe (|)" },
                        { value: "infer", label: "infer (tries to auto detect)" }
                    ],
                },
                {
                    type: "selectCustomizable",
                    tooltip: "Row number containing column labels and marking the start of the data (zero-indexed).",
                    label: "Header",
                    id: "csvOptions.header",
                    placeholder: "Default: first line",
                    options: [
                        { value: "None", label: "None" },
                        { value: "0", label: "First line" },
                        { value: "1", label: "Second Line" }
                    ],
                    advanced: true
                },
                {
                    type: "selectTokenization",
                    tooltip: "Sequence of column labels to apply.",
                    label: "Column names",
                    id: "csvOptions.names",
                    placeholder: "Type header fields (ordered and comma-separated)",
                    options: [],
                    advanced: true
                },
                {
                    type: "select",
                    label: "On Bad Lines",
                    id: "csvOptions.on_bad_lines",
                    placeholder: "Error: raise an Exception when a bad line is encountered",
                    options: [
                        { value: "error", label: "Error: raise an Exception when a bad line is encountered" },
                        { value: "warn", label: "Warn: raise a warning when a bad line is encountered and skip that line." },
                        { value: "skip", label: "Skip: skip bad lines without raising or warning when they are encountered." }
                    ],
                    advanced: true
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderHandle, {
            type: CsvFileInput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_1__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_1__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: CsvFileInput.Name,
            ConfigForm: CsvFileInput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: CsvFileInput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport,
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, outputName }) {
        // Initialize an object to modify without affecting the original config
        let csvOptions = { ...config.csvOptions };
        // Handle 'infer' option
        if (csvOptions.sep === 'infer') {
            csvOptions.sep = 'None'; // Set sep to Python's None for code generation
            csvOptions.engine = 'python'; // Ensure engine is set to 'python'
        }
        // Adjust handling for 'header' and 'names'
        if (typeof config.header === 'number' || config.header === 'None') {
            csvOptions.header = config.header; // Use the header value directly if it's a number or 'None'
        }
        if (config.names && Array.isArray(config.names) && config.names.length > 0) {
            csvOptions.names = `['${config.names.join("', '")}']`; // Format names as a Python list
            csvOptions.header = 0; // Set header to 0 if names are provided
        }
        // Prepare options string for pd.read_csv
        let optionsString = Object.entries(csvOptions)
            .filter(([key, value]) => value !== null && value !== '' && !(key === 'sep' && value === 'infer'))
            .map(([key, value]) => {
            if (key === 'header' && (typeof value === 'number' || value === 'None')) {
                return `${key}=${value}`; // Handle header as number or None without quotes
            }
            else if (key === 'names') {
                return `${key}=${value}`; // Directly use the formatted names list
            }
            else if (typeof value === 'string' && value !== 'None') {
                return `${key}="${value}"`; // Handle strings with quotes, except for 'None'
            }
            else {
                return `${key}=${value}`; // Handle numbers and Python's None without quotes
            }
        })
            .join(', ');
        // Generate the Python code
        const code = `
# Reading data from ${config.filePath}
${outputName} = pd.read_csv("${config.filePath}"${optionsString ? `, ${optionsString}` : ''}).convert_dtypes()
`;
        return code;
    }
}
_a = CsvFileInput;
CsvFileInput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/CsvFileOutput.js":
/*!*****************************************!*\
  !*** ./lib/components/CsvFileOutput.js ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CsvFileOutput: () => (/* binding */ CsvFileOutput)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class CsvFileOutput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "CSV File Output";
        this._id = "csvFileOutput";
        this._type = "pandas_df_output";
        this._category = "output";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.filePlusIcon;
        this._default = { csvOptions: { sep: "," } };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "file",
                    label: "File path",
                    id: "filePath",
                    placeholder: "Type file name",
                    validation: "\\.(csv|tsv|txt)$",
                    validationMessage: "This field expects a file with a csv, tsv or txt extension such as output.csv."
                },
                {
                    type: "selectCustomizable",
                    label: "Separator",
                    id: "csvOptions.sep",
                    placeholder: "auto",
                    options: [
                        { value: ",", label: "comma (,)" },
                        { value: ";", label: "semicolon (;)" },
                        { value: " ", label: "space" },
                        { value: "  ", label: "tab" },
                        { value: "|", label: "pipe (|)" }
                    ],
                },
                {
                    type: "radio",
                    label: "Mode",
                    id: "csvOptions.mode",
                    options: [
                        { value: "w", label: "Write" },
                        { value: "x", label: "Exclusive Creation" },
                        { value: "a", label: "Append" }
                    ],
                    advanced: true
                },
                {
                    type: "boolean",
                    label: "Header",
                    id: "csvOptions.header",
                    advanced: true
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: CsvFileOutput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: CsvFileOutput.Name,
            ConfigForm: CsvFileOutput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: CsvFileOutput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, inputName }) {
        let optionsString = Object.entries(config.csvOptions)
            .filter(([key, value]) => value !== null && value !== '')
            .map(([key, value]) => `${key}='${value}'`)
            .join(', ');
        // Add comma only if optionsString is not empty
        optionsString = optionsString ? `, ${optionsString}` : '';
        const code = `
${inputName}.to_csv("${config.filePath}", index=False${optionsString})
`;
        return code;
    }
}
_a = CsvFileOutput;
CsvFileOutput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/CustomTransformations.js":
/*!*************************************************!*\
  !*** ./lib/components/CustomTransformations.js ***!
  \*************************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   CustomTransformations: () => (/* binding */ CustomTransformations)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class CustomTransformations extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Custom Code";
        this._id = "customTransformations";
        this._type = "pandas_df_processor";
        this._category = "transform";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.codeIcon;
        this._default = { code: "output = input" };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "codeTextarea",
                    label: "Imports",
                    id: "import",
                    placeholder: "import pandas as pd",
                    height: '50px',
                    advanced: true
                },
                {
                    type: "codeTextarea",
                    label: "Code",
                    id: "code",
                    mode: "python",
                    height: '300px',
                    placeholder: "output = input",
                    advanced: true
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: CustomTransformations.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: CustomTransformations.Name,
            ConfigForm: CustomTransformations.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: CustomTransformations.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport,
        })));
    }
    provideImports(config) {
        return config.imports ? config.imports.split('\n').filter(line => line.startsWith('import ')) : [];
    }
    generateComponentCode({ config, inputName, outputName }) {
        let code = `\n${config.code}`.replace(/input/g, inputName);
        code = code.replace(/output/g, outputName);
        return code;
    }
}
_a = CustomTransformations;
CustomTransformations.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/Deduplicate.js":
/*!***************************************!*\
  !*** ./lib/components/Deduplicate.js ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Deduplicate: () => (/* binding */ Deduplicate)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class Deduplicate extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Deduplicate";
        this._id = "deduplicateData";
        this._type = "pandas_df_processor";
        this._category = "transform";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.dedupIcon; // Assuming codeIcon is imported or defined elsewhere
        this._default = { keep: "first" };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "select",
                    label: "Keep (survivorship)",
                    id: "keep",
                    options: [
                        { value: "first", label: "Drop duplicates except for the first occurrence" },
                        { value: "last", label: "Drop duplicates except for the last occurrence" },
                        { value: false, label: "Drop all duplicates" }
                    ],
                },
                {
                    type: "columns",
                    label: "Columns",
                    id: "subset",
                    placeholder: "All columns",
                    tooltip: "Columns considered for identifying duplicates. Leave empty to consider all columns."
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: Deduplicate.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: Deduplicate.Name,
            ConfigForm: Deduplicate.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: Deduplicate.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, inputName, outputName }) {
        // Initializing code string
        let code = `
# Deduplicate rows\n`;
        const columns = config.subset.length > 0 ? `subset=[${config.subset.map(column => column.named ? `"${column.value.trim()}"` : column.value).join(', ')}]` : '';
        const keep = typeof config.keep === 'boolean' ? (config.keep ? `"first"` : '') : `"${config.keep}"`;
        // Generating the Python code for deduplication
        code += `${outputName} = ${inputName}.drop_duplicates(${columns}${keep ? `, keep=${keep}` : ''})\n`;
        return code;
    }
}
_a = Deduplicate;
Deduplicate.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/EnvVariables.js":
/*!****************************************!*\
  !*** ./lib/components/EnvVariables.js ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   EnvVariables: () => (/* binding */ EnvVariables)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! antd */ "webpack/sharing/consume/default/antd/antd");
/* harmony import */ var antd__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(antd__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _ant_design_icons__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! @ant-design/icons */ "../../node_modules/@ant-design/icons/es/icons/DeleteOutlined.js");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_3___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_3__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;






class EnvVariables extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Env. Variables";
        this._id = "envVariables";
        this._type = "env_variables";
        this._category = "other";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_4__.mergeIcon;
        this._default = {};
        this._form = {};
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_3__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_3__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_3__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_3__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: EnvVariables.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_3__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_3__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: EnvVariables.Name,
            ConfigForm: EnvVariables.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: EnvVariables.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import os"];
    }
    generateComponentCode({ config }) {
        let code = ``;
        config.variables.forEach(variable => {
            // Initialize all environment variables to an empty string or the default value if provided
            if (variable.value) {
                code += `os.environ["${variable.name}"] = "${variable.value}"\n`;
            }
        });
        code += "\n";
        return code;
    }
}
_a = EnvVariables;
EnvVariables.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    // Define your default config
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    const EditableContext = react__WEBPACK_IMPORTED_MODULE_1___default().createContext(null);
    const EditableRow = ({ index, ...props }) => {
        const [form] = antd__WEBPACK_IMPORTED_MODULE_2__.Form.useForm();
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(antd__WEBPACK_IMPORTED_MODULE_2__.Form, { form: form, component: false },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(EditableContext.Provider, { value: form },
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement("tr", { ...props }))));
    };
    const EditableCell = ({ title, editable, children, dataIndex, record, handleSave, required, ...restProps }) => {
        const [editing, setEditing] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(false);
        const inputRef = (0,react__WEBPACK_IMPORTED_MODULE_1__.useRef)(null);
        const form = (0,react__WEBPACK_IMPORTED_MODULE_1__.useContext)(EditableContext);
        (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
            var _b;
            if (editing) {
                (_b = inputRef.current) === null || _b === void 0 ? void 0 : _b.focus();
            }
        }, [editing]);
        const toggleEdit = () => {
            setEditing(!editing);
            form.setFieldsValue({ [dataIndex]: record[dataIndex] });
        };
        const save = async () => {
            try {
                const values = await form.validateFields();
                toggleEdit();
                handleSave({ ...record, ...values });
            }
            catch (errInfo) {
                console.log('Save failed:', errInfo);
            }
        };
        let childNode = children;
        if (editable) {
            childNode = editing ? (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(antd__WEBPACK_IMPORTED_MODULE_2__.Form.Item, { style: { margin: 0 }, name: dataIndex, rules: required ? [
                    {
                        required: true,
                        message: `${title} is required.`,
                    },
                ] : [] },
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(antd__WEBPACK_IMPORTED_MODULE_2__.Input, { ref: inputRef, onPressEnter: save, onBlur: save, onKeyDown: (e) => e.stopPropagation(), autoComplete: "off" }))) : (react__WEBPACK_IMPORTED_MODULE_1___default().createElement("div", { className: "editable-cell-value-wrap", style: { paddingRight: 24, minHeight: '20px', width: '100%', display: 'inline-block' }, onClick: () => toggleEdit() }, children));
        }
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement("td", { ...restProps },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement("div", { onDoubleClick: (e) => e.stopPropagation() }, childNode)));
    };
    const [dataSource, setDataSource] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(data.variables || []);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleChange(dataSource, "variables");
    }, [dataSource]);
    const [count, setCount] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(dataSource.length || 0);
    const handleDelete = (key) => {
        const newData = dataSource.filter((item) => item.key !== key);
        setDataSource(newData);
    };
    const defaultColumns = [
        {
            title: 'Name',
            dataIndex: 'name',
            width: '30%',
            editable: true,
            required: true
        },
        {
            title: 'Value',
            dataIndex: 'value',
            width: '40%',
            editable: true,
            required: false
        },
        {
            title: 'Default',
            dataIndex: 'default',
            width: '30%',
            editable: true,
            required: false
        },
        {
            title: '',
            dataIndex: 'operation',
            render: (_, record) => dataSource.length >= 1 ? (react__WEBPACK_IMPORTED_MODULE_1___default().createElement(antd__WEBPACK_IMPORTED_MODULE_2__.Popconfirm, { title: "Sure to delete?", onConfirm: () => handleDelete(record.key) },
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_ant_design_icons__WEBPACK_IMPORTED_MODULE_5__["default"], null))) : null,
        }
    ];
    const handleAdd = () => {
        const newData = {
            key: count,
            name: `ENV_${count}`,
            value: '',
            default: ``,
        };
        setDataSource([...dataSource, newData]);
        setCount(count + 1);
    };
    const handleSave = (row) => {
        const newData = [...dataSource];
        const index = newData.findIndex((item) => row.key === item.key);
        const item = newData[index];
        newData.splice(index, 1, {
            ...item,
            ...row,
        });
        setDataSource(newData);
    };
    const components = {
        body: {
            row: EditableRow,
            cell: EditableCell,
        },
    };
    const columns = defaultColumns.map((col) => {
        if (!col.editable) {
            return col;
        }
        return {
            ...col,
            onCell: (record) => ({
                record,
                editable: col.editable,
                dataIndex: col.dataIndex,
                title: col.title,
                required: col.required,
                handleSave,
            }),
        };
    });
    const [modal2Open, setModal2Open] = (0,react__WEBPACK_IMPORTED_MODULE_1__.useState)(false);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null,
        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(antd__WEBPACK_IMPORTED_MODULE_2__.ConfigProvider, { theme: {
                token: {
                    // Seed Token
                    colorPrimary: '#5F9B97',
                },
            } },
            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(antd__WEBPACK_IMPORTED_MODULE_2__.Form, { layout: "vertical", size: "small" },
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement("div", { className: "flex justify-center mt-1 pt-1.5 space-x-4" },
                    react__WEBPACK_IMPORTED_MODULE_1___default().createElement("span", { onClick: () => setModal2Open(true), className: "inline-flex items-center justify-center cursor-pointer group" },
                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_icons__WEBPACK_IMPORTED_MODULE_4__.settingsIcon.react, { className: "h-3 w-3 group-hover:text-primary" }))),
                react__WEBPACK_IMPORTED_MODULE_1___default().createElement(antd__WEBPACK_IMPORTED_MODULE_2__.Modal, { title: _a.Name, centered: true, open: modal2Open, onOk: () => setModal2Open(false), onCancel: () => setModal2Open(false), width: 800, footer: (_, { OkBtn }) => (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null,
                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement(OkBtn, null))) },
                    react__WEBPACK_IMPORTED_MODULE_1___default().createElement(antd__WEBPACK_IMPORTED_MODULE_2__.Form, { layout: "vertical" },
                        react__WEBPACK_IMPORTED_MODULE_1___default().createElement("div", null,
                            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(antd__WEBPACK_IMPORTED_MODULE_2__.Button, { onClick: handleAdd, type: "primary", style: { marginBottom: 16 } }, "Add environment variable"),
                            react__WEBPACK_IMPORTED_MODULE_1___default().createElement(antd__WEBPACK_IMPORTED_MODULE_2__.Table, { components: components, rowClassName: () => 'editable-row', bordered: true, dataSource: dataSource, columns: columns }))))))));
};



/***/ }),

/***/ "./lib/components/ExcelFileInput.js":
/*!******************************************!*\
  !*** ./lib/components/ExcelFileInput.js ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ExcelFileInput: () => (/* binding */ ExcelFileInput)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class ExcelFileInput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Excel File Input";
        this._id = "excelfileInput";
        this._type = "pandas_df_input";
        this._category = "input";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.fileTextIcon;
        this._default = {};
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "file",
                    label: "File path",
                    id: "filePath",
                    placeholder: "Type file name",
                    validation: "\\.(xlsx)$",
                    validationMessage: "This field expects a file with a xlsx extension such as input.xlsx."
                },
                {
                    type: "selectCustomizable",
                    label: "Sheets",
                    id: "excelOptions.sheet",
                    placeholder: "Default: O (first sheet)",
                    options: [
                        { value: "0", label: "0" },
                        { value: "1", label: "1t" },
                        { value: "[0, 1, 'Sheet5']", label: "[0, 1, 'Sheet5']" },
                        { value: "None", label: "All" }
                    ],
                },
                {
                    type: "selectCustomizable",
                    label: "Header",
                    id: "excelOptions.header",
                    placeholder: "default: 0 (first row)",
                    options: [
                        { value: "0", label: "0 (1st row)" },
                        { value: "1", label: "1 (2nd row)" },
                        { value: "None", label: "None (No header)" }
                    ],
                    advanced: true
                },
                {
                    type: "boolean",
                    label: "Verbose",
                    id: "excelOptions.verbose",
                    placeholder: "false",
                    advanced: true
                },
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderHandle, {
            type: ExcelFileInput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_1__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_1__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: ExcelFileInput.Name,
            ConfigForm: ExcelFileInput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: ExcelFileInput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, outputName }) {
        let optionsString = config.excelOptions ?
            Object.entries(config.excelOptions)
                .filter(([key, value]) => value !== null && value !== '')
                .map(([key, value]) => `${key}='${value}'`)
                .join(', ')
            : null;
        const code = optionsString
            ? `${outputName} = pd.read_excel("${config.filePath}", ${optionsString}).convert_dtypes()
`
            : `${outputName} = pd.read_excel("${config.filePath}").convert_dtypes()
`;
        return code;
    }
}
_a = ExcelFileInput;
ExcelFileInput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/ExcelFileOutput.js":
/*!*******************************************!*\
  !*** ./lib/components/ExcelFileOutput.js ***!
  \*******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ExcelFileOutput: () => (/* binding */ ExcelFileOutput)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class ExcelFileOutput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Excel File Output";
        this._id = "excelFileOutput";
        this._type = "pandas_df_output";
        this._category = "output";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.filePlusIcon;
        this._default = { excelOptions: {} };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "file",
                    label: "File path",
                    id: "filePath",
                    placeholder: "Type file name",
                    validation: "\\.(xlsx)$",
                    validationMessage: "This field expects a file with a xlsx extension such as output.xlsx."
                },
                {
                    type: "input",
                    label: "Sheet",
                    id: "excelOptions.sheet",
                    placeholder: "default: Sheet1"
                },
                {
                    type: "radio",
                    label: "Mode",
                    id: "mode",
                    options: [
                        { value: "write", label: "Write" },
                        { value: "append", label: "Append" }
                    ],
                    advanced: true
                },
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: ExcelFileOutput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: ExcelFileOutput.Name,
            ConfigForm: ExcelFileOutput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: ExcelFileOutput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideDependencies({ config }) {
        let deps = [];
        deps.push('openpyxl');
        return deps;
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, inputName }) {
        let excelWriterNeeded = config.excelOptions.mode === 'a';
        let options = { ...config.excelOptions };
        // Remove mode from options as it's handled separately
        delete options.mode;
        // Construct options string, adding sheet if specified
        let optionsString = Object.entries(options)
            .filter(([key, value]) => value !== null && value !== '')
            .map(([key, value]) => `${key}='${value}'`)
            .join(', ');
        optionsString = optionsString ? `, ${optionsString}` : '';
        let code = '';
        if (excelWriterNeeded) {
            code = `with pd.ExcelWriter("${config.filePath}", mode="a") as writer:\n` +
                `    ${inputName}.to_excel(writer, index=False${optionsString})
  `;
        }
        else {
            code = `
${inputName}.to_excel("${config.filePath}", index=False${optionsString})
  `;
        }
        return code;
    }
}
_a = ExcelFileOutput;
ExcelFileOutput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/ExpandList.js":
/*!**************************************!*\
  !*** ./lib/components/ExpandList.js ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ExpandList: () => (/* binding */ ExpandList)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class ExpandList extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Expand JSON List";
        this._id = "expandList";
        this._type = "pandas_df_processor";
        this._category = "transform";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.expandIcon;
        this._default = {};
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "column",
                    label: "Column",
                    id: "column",
                    placeholder: "Select column",
                }
            ]
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: ExpandList.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: ExpandList.Name,
            ConfigForm: ExpandList.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: ExpandList.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, inputName, outputName }) {
        // Start generating the code string
        let code = `# Expand the list in the specified column\n`;
        code += `import pandas as pd\n`; // Ensure pandas is imported
        code += `${outputName} = ${inputName}["${config.column.value}"].apply(pd.Series)\n`;
        return code;
    }
}
_a = ExpandList;
ExpandList.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/Extract.js":
/*!***********************************!*\
  !*** ./lib/components/Extract.js ***!
  \***********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Extract: () => (/* binding */ Extract)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class Extract extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Extract";
        this._id = "extract";
        this._type = "pandas_df_processor";
        this._category = "transform";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.extractIcon;
        this._default = {};
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "column",
                    label: "Column name",
                    id: "column",
                    placeholder: "Column name",
                },
                {
                    type: "selectCustomizable",
                    label: "Regular Expression",
                    id: "regex",
                    tooltip: "Select of a type of data or add a custom regex",
                    placeholder: "Select type or type regex",
                    options: [
                        { value: "(\\b[A-Za-z0-9._%+-]+@[A-Za-z0-9.-]+\\.[A-Z|a-z]{2,}\\b)", label: "Email" },
                        { value: "(https?://(?:www\\.)?[-a-zA-Z0-9@:%._\\+~#=]{2,256}\\.[a-z]{2,6}\\b(?:[-a-zA-Z0-9@:%_\\+.~#?&//=]*))", label: "URL" },
                        { value: "(\\b\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}\\b)", label: "IPv4 Address" },
                        { value: "(([0-9a-fA-F]{1,4}:){7,7}[0-9a-fA-F]{1,4}|([0-9a-fA-F]{1,4}:){1,7}:|([0-9a-fA-F]{1,4}:){1,6}:[0-9a-fA-F]{1,4})", label: "IPv6 Address" },
                        { value: "(\\b\\d{4}[- ]?\\d{4}[- ]?\\d{4}[- ]?\\d{4}\\b)", label: "Credit Card" },
                        { value: "(\\b\\d{3}-\\d{2}-\\d{4}\\b)", label: "SSN" },
                        { value: "(\\b\\d{1,3}(\\.\\d{1,2})?%\\b)", label: "Percentage" },
                        { value: "(\"([^\"\\\\]*(\\\\.[^\"\\\\]*)*))", label: "JSON String" },
                        { value: "(\\b\\d{3}-\\d{10}\\b)", label: "ISBN" }
                    ]
                },
                {
                    type: "select",
                    label: "Flags",
                    id: "flags",
                    placeholder: "Type or select",
                    options: [
                        { value: "IGNORECASE", label: "Makes the match case-insensitive. For example, it will match both 'abc' and 'ABC'." },
                        { value: "MULTILINE", label: "Changes the behavior of ^ and $ to match the start and end of each line, not just the start and end of the whole string." },
                        { value: "DOTALL", label: "Makes the . match any character at all, including a newline; without this flag, . will match anything except a newline." },
                        { value: "UNICODE", label: "Makes \\w, \\W, \\b, \\B, \\d, \\D, \\s, and \\S sequences dependent on the Unicode character properties database. This is the default behavior in Python 3 for strings." },
                        { value: "ASCII", label: "Makes \\w, \\W, \\b, \\B, \\d, \\D, \\s, and \\S perform ASCII-only matching instead of full Unicode matching." },
                        { value: "VERBOSE", label: "Allows you to write regular expressions that are more readable by permitting whitespace and comments within the pattern string." }
                    ],
                    advanced: true
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: Extract.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: Extract.Name,
            ConfigForm: Extract.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: Extract.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd", "import re"];
    }
    generateComponentCode({ config, inputName, outputName }) {
        const columnName = config.column.value; // name of the column
        const columnType = config.column.type; // current type of the column (e.g., 'int', 'string')
        const columnNamed = config.column.named; // boolean, true if column is named, false if index is used
        const columnAccess = columnNamed ? `['${columnName}']` : `[${columnName}]`;
        const regex = config.regex;
        let flagsCode = '';
        // Check if flags are not empty before formatting
        if (config.falgs && config.flags.trim() !== '') {
            const flags = config.flags.split(',')
                .filter(flag => flag.trim() !== '')
                .map(flag => `re.${flag}`)
                .join(' | ');
            flagsCode = `, flags=${flags}`;
        }
        // Count the number of capturing groups in the regex
        const groupCount = (new RegExp(regex + '|')).exec('').length - 1;
        const columnNames = Array.from({ length: groupCount }, (_, i) => `"${outputName}_${i + 1}"`).join(', ');
        // Use outputName to create unique names for the extracted data
        const extractedVarName = `${outputName}_extracted`;
        // Generate the final code string
        const code = `
# Extract data using regex
${extractedVarName} = ${inputName}[${columnAccess}].str.extract(r"${regex}"${flagsCode})
${extractedVarName}.columns = [${columnNames}]
${outputName} = ${inputName}.join(${extractedVarName}, rsuffix="_extracted")
`;
        return code;
    }
}
_a = Extract;
Extract.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/Filter.js":
/*!**********************************!*\
  !*** ./lib/components/Filter.js ***!
  \**********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Filter: () => (/* binding */ Filter)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class Filter extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Filter Rows";
        this._id = "filter";
        this._type = "pandas_df_processor";
        this._category = "transform";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.filterIcon;
        this._default = { condition: "==" };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "column",
                    label: "Column name",
                    id: "column",
                    placeholder: "Select column",
                },
                {
                    type: "select",
                    label: "Condition",
                    id: "condition",
                    placeholder: "Select condition",
                    options: [
                        { "value": "==", "label": "==" },
                        { "value": "!=", "label": "!=" },
                        { "value": ">", "label": ">" },
                        { "value": "<", "label": "<" },
                        { "value": ">=", "label": ">=" },
                        { "value": "<=", "label": "<=" },
                        { "value": "notnull", "label": "Not Null" },
                        { "value": "notempty", "label": "Not Empty" },
                        { "value": "contains", "label": "Contains (string)" },
                        { "value": "not contains", "label": "Not contains (string)" },
                        { "value": "startswith", "label": "Starts With (string)" },
                        { "value": "endswith", "label": "Ends With (string)" },
                        { "value": "is NaN", "label": "Is Not a Number (Leave value field empty)" },
                        { "value": "is not N", "label": "Is a Number (Leave value field empty)" }
                    ],
                },
                {
                    type: "input",
                    label: "Value",
                    id: "conditionValue",
                    placeholder: "Any string of characters (enforce numbers if needed)"
                },
                {
                    type: "boolean",
                    label: "Enforce value as string",
                    id: "enforceString",
                    advanced: true
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: Filter.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: Filter.Name,
            ConfigForm: Filter.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: Filter.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, inputName, outputName }) {
        const columnName = config.column.value;
        const columnType = config.column.type;
        const columnIsNamed = config.column.named;
        const condition = config.condition;
        const conditionValue = config.conditionValue;
        const enforceString = config.enforceString;
        let formattedConditionValue;
        switch (columnType) {
            case 'string':
            case 'Object':
            case 'category':
                formattedConditionValue = `${conditionValue.toString().replace(/"/g, '\\"')}`;
                break;
            case 'datetime64':
                formattedConditionValue = `${new Date(conditionValue).toISOString()}`;
                break;
            case 'bool':
                formattedConditionValue = conditionValue.toString().toLowerCase();
                break;
            case 'timedelta[ns]':
                formattedConditionValue = `pd.to_timedelta(${conditionValue}, unit='ms')`;
                break;
            case 'period':
                formattedConditionValue = `P${conditionValue.toString()}`;
                break;
            default:
                formattedConditionValue = !isNaN(Number(conditionValue)) ? conditionValue.toString() : `'${conditionValue.toString()}'`;
                break;
        }
        let code = `
# Filter rows based on condition
`;
        let queryExpression;
        switch (condition) {
            case "==":
            case "!=":
                queryExpression = `${columnName} ${condition} '${formattedConditionValue}'`;
                code += `${outputName} = ${inputName}.query("${queryExpression}")`;
                break;
            case "contains":
            case "not contains":
                if (['string', 'Object', 'category'].includes(columnType)) {
                    const negation = condition === "not contains" ? "~" : "";
                    queryExpression = `${negation}${inputName}[${inputName}['${columnName}'].str.contains("${formattedConditionValue}", na=False)]`;
                    code += `${outputName} = ${queryExpression}`;
                }
                else {
                    throw new Error('Invalid operation for the data type');
                }
                break;
            case "startswith":
            case "endswith":
                if (['string', 'Object', 'category'].includes(columnType)) {
                    queryExpression = `${inputName}[${inputName}['${columnName}'].str.${condition}("${formattedConditionValue.slice(1, -1)}", na=False)]`;
                    code += `${outputName} = ${queryExpression}`;
                }
                else {
                    throw new Error('Invalid operation for the data type');
                }
                break;
            case "isna":
            case "notna":
                queryExpression = `${inputName}[${inputName}['${columnName}'].${condition}()]`;
                code += `${outputName} = ${queryExpression}`;
                break;
            default:
                queryExpression = `${columnName} ${condition} '${formattedConditionValue}'`;
                code += `${outputName} = ${inputName}.query("${queryExpression}")`;
                break;
        }
        return code;
    }
}
_a = Filter;
Filter.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/FilterColumns.js":
/*!*****************************************!*\
  !*** ./lib/components/FilterColumns.js ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   FilterColumns: () => (/* binding */ FilterColumns)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class FilterColumns extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Drop Columns";
        this._id = "filterColumn";
        this._type = "pandas_df_processor";
        this._category = "transform";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.crosshairIcon;
        this._default = { columns: { sourceData: [], targetKeys: [] } };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "transferData",
                    label: "Filter columns",
                    id: "columns",
                    advanced: true
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: FilterColumns.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: FilterColumns.Name,
            ConfigForm: FilterColumns.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: FilterColumns.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, inputName, outputName }) {
        const allColumns = config.columns.sourceData;
        const targetKeys = config.columns.targetKeys;
        // Prepare column references, handling named and unnamed columns
        const columnsToKeep = targetKeys.map(key => {
            const column = allColumns.find(c => c.value === key);
            return column && column.named ? `"${key.trim()}"` : `${key.trim()}`;
        }).join(', ');
        // Python code generation for DataFrame operation
        const code = `
# Filter and order columns
${outputName} = ${inputName}[[${columnsToKeep}]]
`;
        return code;
    }
}
_a = FilterColumns;
FilterColumns.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/GoogleSheetsInput.js":
/*!*********************************************!*\
  !*** ./lib/components/GoogleSheetsInput.js ***!
  \*********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   GoogleSheetsInput: () => (/* binding */ GoogleSheetsInput)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class GoogleSheetsInput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "G. Sheets Input";
        this._id = "googleSheetsInput";
        this._type = "pandas_df_input";
        this._category = "input";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.googleSheetsIcon; // Replace with your actual icon
        this._default = { sheetOptions: { spreadsheetId: "", range: "Sheet1" } };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "file",
                    label: "Service Account Key",
                    id: "filePath",
                    placeholder: "Type file name",
                    validation: "\\.(json)$",
                    validationMessage: "This field expects a file with a .json extension such as your-service-account-file.json.",
                    advanced: true
                },
                {
                    type: "input",
                    label: "Spreadsheet ID",
                    id: "sheetOptions.spreadsheetId",
                    placeholder: "Enter Google Sheets' name or ID",
                    validation: "^[a-zA-Z0-9-_]+$",
                    validationMessage: "Invalid Spreadsheet ID."
                },
                {
                    type: "input",
                    label: "Range",
                    id: "sheetOptions.range",
                    placeholder: "e.g., Sheet1 or Sheet1!A1:D5",
                    validation: "^[a-zA-Z0-9-_!]+$",
                    validationMessage: "Invalid Range."
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderHandle, {
            type: GoogleSheetsInput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_1__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_1__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: GoogleSheetsInput.Name,
            ConfigForm: GoogleSheetsInput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: GoogleSheetsInput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport,
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd", "import gspread", "from oauth2client.service_account import ServiceAccountCredentials"];
    }
    generateComponentCode({ config, outputName }) {
        // Initialize an object to modify without affecting the original config
        let sheetOptions = { ...config.sheetOptions };
        // Check if service account file path is provided and not empty
        const isServiceAccountProvided = !!config.filePath && config.filePath.trim() !== '';
        // Prepare options string for pd.read_gbq
        let optionsString = Object.entries(sheetOptions)
            .filter(([key, value]) => value !== null && value !== '')
            .map(([key, value]) => `${key}="${value}"`)
            .join(', ');
        // Unique variables for each instance
        const uniqueClientVar = `${outputName}Client`;
        const uniqueSheetVar = `${outputName}Sheet`;
        // Conditional code based on service account availability
        let authenticationCode = isServiceAccountProvided ?
            `# Authentication with service account
scope = ["https://spreadsheets.google.com/feeds","https://www.googleapis.com/auth/drive"]
creds = ServiceAccountCredentials.from_json_keyfile_name("${config.filePath}", scope)
${uniqueClientVar} = gspread.authorize(creds)
` :
            `# Accessing public sheet without authentication
${uniqueClientVar} = gspread.service_account()
`;
        // Generate the Python code for reading data from Google Sheets
        const code = `
# Reading data from Google Sheets
${authenticationCode}
# Open the spreadsheet
${uniqueSheetVar} = ${uniqueClientVar}.open_by_key(${sheetOptions.spreadsheetId ? `"${sheetOptions.spreadsheetId}"` : 'None'}).worksheet(${sheetOptions.range ? `"${sheetOptions.range.split('!')[0]}"` : 'None'})
  
# Convert to DataFrame
${outputName} = pd.DataFrame(${uniqueSheetVar}.get_all_records())
`;
        return code;
    }
}
_a = GoogleSheetsInput;
GoogleSheetsInput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/GoogleSheetsOutput.js":
/*!**********************************************!*\
  !*** ./lib/components/GoogleSheetsOutput.js ***!
  \**********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   GoogleSheetsOutput: () => (/* binding */ GoogleSheetsOutput)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class GoogleSheetsOutput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "G. Sheets Output";
        this._id = "googleSheetsOutput";
        this._type = "pandas_df_output";
        this._category = "output";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.googleSheetsIcon; // Replace with your actual icon
        this._default = { sheetOptions: { spreadsheetId: "", range: "Sheet1" } };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "file",
                    label: "Service Account Key",
                    id: "filePath",
                    placeholder: "Type file name",
                    validation: "\\.(json)$",
                    validationMessage: "This field expects a file with a .json extension such as your-service-account-file.json."
                },
                {
                    type: "input",
                    label: "Spreadsheet ID",
                    id: "sheetOptions.spreadsheetId",
                    placeholder: "Enter Google Sheets' name or ID",
                    validation: "^[a-zA-Z0-9-_]+$",
                    validationMessage: "Invalid Spreadsheet ID."
                },
                {
                    type: "input",
                    label: "Range",
                    id: "sheetOptions.range",
                    placeholder: "e.g., Sheet1 or Sheet1!A1:D5",
                    validation: "^[a-zA-Z0-9-_!]+$",
                    validationMessage: "Invalid Range."
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderHandle, {
            type: GoogleSheetsOutput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_1__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_1__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: GoogleSheetsOutput.Name,
            ConfigForm: GoogleSheetsOutput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: GoogleSheetsOutput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport,
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd", "import gspread", "from oauth2client.service_account import ServiceAccountCredentials"];
    }
    generateComponentCode({ config, inputName }) {
        // Initialize an object to modify without affecting the original config
        let sheetOptions = { ...config.sheetOptions };
        // Validate and set the service account file path
        const serviceAccountFilePath = config.filePath ? `"${config.filePath}"` : 'None';
        // Unique variables for each instance
        const uniqueClientVar = `${inputName}Client`;
        const uniqueSheetVar = `${inputName}Sheet`;
        // Generate the Python code for outputting data to Google Sheets
        const code = `
# Outputting data to Google Sheets
scope = ["https://spreadsheets.google.com/feeds","https://www.googleapis.com/auth/drive"]
creds = ServiceAccountCredentials.from_json_keyfile_name(${serviceAccountFilePath}, scope)
${uniqueClientVar} = gspread.authorize(creds)

# Open the spreadsheet and select the right worksheet
${uniqueSheetVar} = ${uniqueClientVar}.open_by_key(${sheetOptions.spreadsheetId ? `"${sheetOptions.spreadsheetId}"` : 'None'}).worksheet(${sheetOptions.range ? `"${sheetOptions.range.split('!')[0]}"` : 'None'})

# Update the sheet with dataframe's data
${uniqueSheetVar}.update([${inputName}.columns.values.tolist()] + ${inputName}.values.tolist())
`;
        return code;
    }
}
_a = GoogleSheetsOutput;
GoogleSheetsOutput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/HtmlFileInput.js":
/*!*****************************************!*\
  !*** ./lib/components/HtmlFileInput.js ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   HtmlFileInput: () => (/* binding */ HtmlFileInput)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class HtmlFileInput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = 'HTML File Input';
        this._id = 'htmlInput';
        this._type = 'pandas_df_input';
        this._fileDrop = ["html", "htm"];
        this._category = 'input';
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.fileTextIcon;
        this._default = {};
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "file",
                    label: "File path",
                    id: "filePath",
                    placeholders: "Select or type file",
                    validation: "\\.(html|htm)$",
                    validationMessage: "This field expects a file with a html or htm extension such as index.html."
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderHandle, {
            type: HtmlFileInput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_1__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_1__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: HtmlFileInput.Name,
            ConfigForm: HtmlFileInput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: HtmlFileInput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        let imports = [];
        imports.push('import pandas as pd');
        imports.push('from unstructured.partition.html import partition_html');
        imports.push('from unstructured.staging.base import convert_to_dataframe');
        return imports;
    }
    generateComponentCode({ config, outputName }) {
        let code = '';
        const optionsString = Object.entries(config.jsonOptions || {})
            .filter(([key, value]) => value !== null && value !== '')
            .map(([key, value]) => `${key}='${value}'`)
            .join(', ');
        const optionsCode = optionsString ? `, ${optionsString}` : ''; // Only add optionsString if it exists
        // Initial code for loading HTML
        code += `
# Retrieve raw HTML from ${config.filePath}
${outputName}_elements = partition_html(filename="${config.filePath}")
${outputName} = convert_to_dataframe(${outputName}_elements)
`;
        return code;
    }
}
_a = HtmlFileInput;
HtmlFileInput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/Join.js":
/*!********************************!*\
  !*** ./lib/components/Join.js ***!
  \********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Join: () => (/* binding */ Join)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class Join extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Join Datasets";
        this._id = "join";
        this._type = "pandas_df_double_processor";
        this._category = "transform";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.mergeIcon;
        this._default = { condition: "==" };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "column",
                    label: "First Input Column",
                    id: "leftKeyColumn",
                    placeholder: "Column name",
                    inputNb: 1
                },
                {
                    type: "column",
                    label: "Second Input Column",
                    id: "rightKeyColumn",
                    placeholder: "Column name",
                    inputNb: 2
                },
                {
                    type: "select",
                    label: "Join type",
                    id: "how",
                    placeholder: "Default: Inner",
                    options: [
                        { value: "inner", label: "Inner: return only the rows with matching keys in both data frames (intersection)." },
                        { value: "left", label: "Left: return all rows from the left data frame and matched rows from the right data frame (including NaN for no match)." },
                        { value: "right", label: "Right: return all rows from the right data frame and matched rows from the left data frame (including NaN for no match)." },
                        { value: "outer", label: "Outer: return all rows from both data frames, with matches where available and NaN for no match (union)." }
                    ],
                    advanced: true
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: Join.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: Join.Name,
            ConfigForm: Join.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: Join.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, inputName1, inputName2, outputName }) {
        // column.value = name, column.type = type, column.name = boolean if column is named or false if numeric index
        const { value: leftKeyColumnValue, type: leftKeyColumnType, named: leftKeyColumnNamed } = config.leftKeyColumn;
        const { value: rightKeyColumnValue, type: rightKeyColumnType, named: rightKeyColumnNamed } = config.rightKeyColumn;
        // Modify to handle non-named (numeric index) columns by removing quotes
        const leftKey = leftKeyColumnNamed ? `"${leftKeyColumnValue}"` : leftKeyColumnValue;
        const rightKey = rightKeyColumnNamed ? `"${rightKeyColumnValue}"` : rightKeyColumnValue;
        const joinType = config.how ? `, how="${config.how}"` : '';
        const code = `
# Join ${inputName1} and ${inputName2}
${outputName} = pd.merge(${inputName1}, ${inputName2}, left_on=${leftKey}, right_on=${rightKey}${joinType})
`;
        return code;
    }
}
_a = Join;
Join.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/JsonFileInput.js":
/*!*****************************************!*\
  !*** ./lib/components/JsonFileInput.js ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   JsonFileInput: () => (/* binding */ JsonFileInput)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class JsonFileInput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = 'JSON File Input';
        this._id = 'jsonFileInput';
        this._type = 'pandas_df_input';
        this._fileDrop = ["json", "jsonl"];
        this._category = 'input';
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.fileTextIcon;
        this._default = { jsonOptions: {} };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "file",
                    label: "File path",
                    id: "filePath",
                    placeholder: "Type file name",
                    validation: "\.(json|jsonl)$",
                    validationMessage: "This field expects a file with a json extension such as input.json."
                },
                {
                    type: "select",
                    label: "Orientation",
                    id: "jsonOptions.orient",
                    placeholder: "default: columns",
                    options: [
                        { value: 'columns', label: 'Columns - JSON object with column labels as keys' },
                        { value: 'records', label: 'Records - List of rows as JSON objects' },
                        { value: 'index', label: 'Index - Dict with index labels as keys' },
                        { value: 'split', label: 'Split - Dict with "index", "columns", and "data" keys' },
                        { value: 'table', label: 'Table - Dict with "schema" and "data" keys, following the Table Schema' }
                    ],
                },
                {
                    type: "boolean",
                    label: "Infer Data Types",
                    id: "jsonOptions.dtype",
                    advanced: true
                },
                {
                    type: "boolean",
                    label: "Line-delimited",
                    id: "jsonOptions.lines",
                    advanced: true
                },
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderHandle, {
            type: JsonFileInput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_1__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_1__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: JsonFileInput.Name,
            ConfigForm: JsonFileInput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: JsonFileInput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, outputName }) {
        // Assuming the JSON options are nested under a jsonOptions key in the config object
        let optionsString = Object.entries(config.jsonOptions || {})
            .filter(([key, value]) => value !== null && value !== '')
            .map(([key, value]) => `${key}="${value}"`)
            .join(', ');
        const optionsCode = optionsString ? `, ${optionsString}` : ''; // Only add optionsString if it exists
        const code = `
${outputName} = pd.read_json("${config.filePath}"${optionsCode}).convert_dtypes()
`;
        return code;
    }
}
_a = JsonFileInput;
JsonFileInput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/JsonFileOutput.js":
/*!******************************************!*\
  !*** ./lib/components/JsonFileOutput.js ***!
  \******************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   JsonFileOutput: () => (/* binding */ JsonFileOutput)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class JsonFileOutput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = 'JSON File Output';
        this._id = 'jsonFileOutput';
        this._type = 'pandas_df_output';
        this._category = 'output';
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.filePlusIcon;
        this._default = { jsonOptions: { "orient": "records" } };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "file",
                    label: "File path",
                    id: "filePath",
                    placeholder: "Type file name",
                    validation: "\.(json|jsonl)$",
                    validationMessage: "This field expects a file with a json or jsonl extension such as output.json."
                },
                {
                    type: "select",
                    label: "Orientation",
                    id: "jsonOptions.orient",
                    placeholder: "Select orientation",
                    options: [
                        { value: "columns", label: "columns (JSON object with column labels as keys)" },
                        { value: "records", label: "records (List of rows as JSON objects)" },
                        { value: "index", label: "index (Dict with index labels as keys)" },
                        { value: "split", label: "split (Dict with 'index', 'columns', and 'data' keys)" },
                        { value: "table", label: "table (Dict with 'schema' and 'data' keys, following the Table Schema)" }
                    ],
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderHandle, {
            type: JsonFileOutput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_1__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_1__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: JsonFileOutput.Name,
            ConfigForm: JsonFileOutput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: JsonFileOutput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, inputName }) {
        let optionsString = Object.entries(config.jsonOptions || {})
            .filter(([key, value]) => value !== null && value !== '')
            .map(([key, value]) => `${key}="${value}"`)
            .join(', ');
        const optionsCode = optionsString ? `, ${optionsString}` : ''; // Only add optionsString if it exists
        const code = `
${inputName}.to_json("${config.filePath}"${optionsCode})
`;
        return code;
    }
}
_a = JsonFileOutput;
JsonFileOutput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/MySQLInput.js":
/*!**************************************!*\
  !*** ./lib/components/MySQLInput.js ***!
  \**************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   MySQLInput: () => (/* binding */ MySQLInput)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class MySQLInput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "MySQL Input";
        this._id = "mySQLInput";
        this._type = "pandas_df_input";
        this._category = "input";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.mySQLIcon; // Adjust if there's a different icon for databases
        this._default = { dbOptions: { host: "localhost", port: "3306", databaseName: "", username: "", password: "", tableName: "" } };
        this._form = {
            fields: [
                {
                    type: "input",
                    label: "Host",
                    id: "dbOptions.host",
                    placeholder: "Enter database host",
                    advanced: true
                },
                {
                    type: "input",
                    label: "Port",
                    id: "dbOptions.port",
                    placeholder: "Enter database port",
                    advanced: true
                },
                {
                    type: "input",
                    label: "Database Name",
                    id: "dbOptions.databaseName",
                    placeholder: "Enter database name",
                },
                {
                    type: "input",
                    label: "Username",
                    id: "dbOptions.username",
                    placeholder: "Enter username",
                    advanced: true
                },
                {
                    type: "input",
                    label: "Password",
                    id: "dbOptions.password",
                    placeholder: "Enter password",
                    inputType: "password",
                    advanced: true
                },
                {
                    type: "input",
                    label: "Table Name",
                    id: "dbOptions.tableName",
                    placeholder: "Enter table name",
                },
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        const handleElement = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderHandle, {
            type: MySQLInput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_1__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_1__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: MySQLInput.Name,
            ConfigForm: MySQLInput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: MySQLInput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport,
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd", "import sqlalchemy", "import pymysql"];
    }
    generateComponentCode({ config, outputName }) {
        let connectionString = `mysql+pymysql://${config.dbOptions.username}:${config.dbOptions.password}@${config.dbOptions.host}:${config.dbOptions.port}/${config.dbOptions.databaseName}`;
        const uniqueEngineName = `${outputName}_Engine`; // Unique engine name based on the outputName
        const code = `
# Connect to the MySQL database
${uniqueEngineName} = sqlalchemy.create_engine("${connectionString}")
with ${uniqueEngineName}.connect() as conn:
  ${outputName} = pd.read_sql_table(
    name="${config.dbOptions.tableName}",
    con=conn.connection
  ).convert_dtypes()
`;
        return code;
    }
}
_a = MySQLInput;
MySQLInput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default;
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/MySQLOutput.js":
/*!***************************************!*\
  !*** ./lib/components/MySQLOutput.js ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   MySQLOutput: () => (/* binding */ MySQLOutput)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;



 // Assuming databaseIcon is an available icon similar to filePlusIcon
class MySQLOutput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "MySQL Output";
        this._id = "mySQLOutput";
        this._type = "pandas_df_output";
        this._category = "output";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.mySQLIcon; // Adjust if there's a different icon for databases
        this._default = { dbOptions: { host: "localhost", port: "3306", databaseName: "", tableName: "", username: "", password: "" }, ifTableExists: "fail", mode: "insert" };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "input",
                    label: "Host",
                    id: "dbOptions.host",
                    placeholder: "Enter database host",
                    advanced: true
                },
                {
                    type: "input",
                    label: "Port",
                    id: "dbOptions.port",
                    placeholder: "Enter database port",
                    advanced: true
                },
                {
                    type: "input",
                    label: "Database Name",
                    id: "dbOptions.databaseName",
                    placeholder: "Enter database name"
                },
                {
                    type: "input",
                    label: "Table Name",
                    id: "dbOptions.tableName",
                    placeholder: "Enter table name",
                },
                {
                    type: "input",
                    label: "Username",
                    id: "dbOptions.username",
                    placeholder: "Enter username",
                    advanced: true
                },
                {
                    type: "input",
                    inputType: "password",
                    label: "Password",
                    id: "dbOptions.password",
                    placeholder: "Enter password",
                    advanced: true
                },
                {
                    type: "radio",
                    label: "If Table Exists",
                    id: "ifTableExists",
                    options: [
                        { value: "fail", label: "Fail" },
                        { value: "replace", label: "Replace" },
                        { value: "append", label: "Append" }
                    ],
                    advanced: true
                },
                {
                    type: "radio",
                    label: "Mode",
                    id: "mode",
                    options: [
                        { value: "insert", label: "INSERT" }
                    ],
                    advanced: true
                },
                {
                    type: "dataMapping",
                    label: "Mapping",
                    id: "mapping",
                    tooltip: "By default the mapping is inferred from the input data. By specifying a schema you override the incoming schema.",
                    outputType: "relationalDatabase",
                    drivers: "mysql+pymysql",
                    typeOptions: [
                        { value: "INT", label: "INT" },
                        { value: "VARCHAR", label: "VARCHAR" },
                        { value: "TEXT", label: "TEXT" },
                        { value: "DATE", label: "DATE" },
                        { value: "DATETIME", label: "DATETIME" },
                        { value: "TIMESTAMP", label: "TIMESTAMP" },
                        { value: "TIME", label: "TIME" },
                        { value: "YEAR", label: "YEAR" },
                        { value: "BOOLEAN", label: "BOOLEAN" },
                        { value: "DECIMAL", label: "DECIMAL" },
                        { value: "FLOAT", label: "FLOAT" },
                        { value: "DOUBLE", label: "DOUBLE" },
                        { value: "BLOB", label: "BLOB" },
                        { value: "BIT", label: "BIT" },
                        { value: "ENUM", label: "ENUM" },
                        { value: "SET", label: "SET" },
                        { value: "JSON", label: "JSON" }
                    ],
                    advanced: true
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: MySQLOutput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: MySQLOutput.Name,
            ConfigForm: MySQLOutput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: MySQLOutput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    // https://stackoverflow.com/questions/63881687/how-to-upsert-pandas-dataframe-to-mysql-with-sqlalchemy
    provideImports({ config }) {
        return ["import pandas as pd", "import sqlalchemy", "import pymysql"];
    }
    generateComponentCode({ config, inputName }) {
        const connectionString = `mysql+pymysql://${config.dbOptions.username}:${config.dbOptions.password}@${config.dbOptions.host}:${config.dbOptions.port}/${config.dbOptions.databaseName}`;
        const uniqueEngineName = `${inputName}Engine`;
        let mappingsCode = "";
        let columnsCode = "";
        const selectedColumns = config.mapping
            .filter(map => { var _b, _c; return map.value !== null && map.value !== undefined && ((_b = map.input) === null || _b === void 0 ? void 0 : _b.value) !== null && ((_c = map.input) === null || _c === void 0 ? void 0 : _c.value) !== undefined; })
            .map(map => `"${map.value}"`)
            .join(', ');
        if (config.mapping && config.mapping.length > 0) {
            const renameMap = config.mapping
                .filter(map => map.input && (map.input.value || typeof map.input.value === 'number'))
                .map(map => {
                if (map.input.value != map.value) {
                    if (map.input.named) {
                        return `"${map.input.value}": "${map.value}"`; // Handles named columns
                    }
                    else {
                        return `${map.input.value}: "${map.value}"`; // Handles numeric index
                    }
                }
                return undefined; // Explicitly return undefined for clarity
            })
                .filter(value => value !== undefined); // Remove undefined values
            if (renameMap.length > 0) {
                mappingsCode = `
# Rename columns based on the mapping
${inputName} = ${inputName}.rename(columns={${renameMap.join(", ")}})
`;
            }
            if (selectedColumns !== '' && selectedColumns !== undefined) {
                columnsCode = `
# Only keep relevant columns
${inputName} = ${inputName}[[${selectedColumns}]]
`;
            }
        }
        const ifExistsAction = config.ifTableExists === "fail" ? "fail" : "replace";
        const code = `
# Connect to MySQL and output into table
${uniqueEngineName} = sqlalchemy.create_engine("${connectionString}")
${mappingsCode}${columnsCode}
${inputName}.to_sql(
  name="${config.dbOptions.tableName}",
  con=${uniqueEngineName},
  if_exists="${ifExistsAction}",
  index=False
)
`;
        return code;
    }
}
_a = MySQLOutput;
MySQLOutput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/OpenAILookUp.js":
/*!****************************************!*\
  !*** ./lib/components/OpenAILookUp.js ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   OpenAILookUp: () => (/* binding */ OpenAILookUp)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class OpenAILookUp extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "OpenAI Prompt";
        this._id = "openAiLookup";
        this._type = "pandas_df_processor";
        this._category = "transform";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.openAiIcon;
        this._default = { maxToken: 256, temperature: 0.3, model: "gpt-3.5-turbo",
            systemPrompt: "You are part of a Python data pipeline using Pandas. Your task is to generate responses for each row of a DataFrame. Just provide the response as short as possible, don't write any sentence." };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "textarea",
                    label: "Prompt",
                    id: "prompt"
                },
                {
                    type: "columns",
                    label: "Columns",
                    tooltip: "Columns data to send with Prompt",
                    id: "columns"
                },
                {
                    type: "textarea",
                    label: "System Prompt",
                    id: "systemPrompt",
                    advanced: true
                },
                {
                    type: "input",
                    label: "API Token",
                    id: "token",
                    advanced: true
                },
                {
                    type: "selectCustomizable",
                    label: "Model",
                    id: "model",
                    options: [
                        { value: "gpt-3.5-turbo", label: "gpt-3.5-turbo" },
                        { value: "gpt-3.5-turbo-16k", label: "gpt-3.5-turbo-16k" },
                        { value: "gpt-4-turbo", label: "gpt-4-turbo" },
                        { value: "gpt-4o", label: "gpt-4o" }
                    ],
                    advanced: true
                },
                {
                    type: "boolean",
                    label: "JSON Mode",
                    id: "jsonMode",
                    advanced: true
                },
                {
                    type: "inputNumber",
                    label: "Max Token",
                    id: "maxToken",
                    min: 1,
                    advanced: true
                },
                {
                    type: "inputNumber",
                    label: "Temperature",
                    id: "temperature",
                    min: 0,
                    max: 1,
                    advanced: true
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: OpenAILookUp.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: OpenAILookUp.Name,
            ConfigForm: OpenAILookUp.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: OpenAILookUp.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd", "from openai import OpenAI"];
    }
    provideFunctions({ config }) {
        let functions = [];
        const code = `
def generate_gpt_response(
  row,  # The data row containing the values
  column_data,  # The list of column names to include in the prompt
  client,  # OpenAI client for generating responses
  user_prompt,  # The initial user prompt text
  system_prompt,  # The system-level instruction
  model,  # The OpenAI model to use
  max_tokens,  # Maximum number of tokens for the response
  temperature  # Controls the variability of the response
):
  # Create a dynamic prompt by including the user prompt and the corresponding data from the specified columns
  column_values = ', '.join([f"{col}: {row[col]}" for col in column_data])  # Construct column-value pairs
  dynamic_prompt = f"{user_prompt}: {column_values}"  # Combine user prompt with column values
  
  # Set up the messages for the OpenAI API request
  messages = [
      {"role": "system", "content": system_prompt},  # System-level context
      {"role": "user", "content": dynamic_prompt},  # User prompt with dynamic content
  ]
  
  # Call OpenAI's ChatCompletion endpoint to generate the response
  response = client.chat.completions.create(
      model=model,  # GPT model used for response generation
      messages=messages,  # Include system and user prompts
      max_tokens=max_tokens,  # Maximum response length
      temperature=temperature  # Variability in response generation
  )
  
  # Return the generated response's content
  return response.choices[0].message.content
`;
        functions.push(code);
        return functions;
    }
    generateComponentCode({ config, inputName, outputName }) {
        // Extract the column names from the config object
        const columnNames = config.columns.map((col) => col.value);
        // Generate Python code to configure OpenAI API and process data
        const code = `
# Set the OpenAI API key for authentication
${outputName}_client = OpenAI(
  # This is the default and can be omitted
  api_key="${config.token}"
)

# OpenAI request parameters
${outputName}_user_prompt = "${config.prompt}"
${outputName}_system_prompt = "${config.systemPrompt}"
${outputName}_model = "${config.model}"  # Model to use for generating responses
${outputName}_max_tokens = ${config.maxToken}  # Maximum number of tokens for the generated response
${outputName}_temperature = ${config.temperature}  # Response variability based on the specified temperature

# Apply the function to generate output for each row
${inputName}['gpt_${outputName}'] = ${inputName}.apply(lambda row: generate_gpt_response(
  row, 
  ["${columnNames.join('", "')}"], 
  ${outputName}_client,
  ${outputName}_user_prompt,
  ${outputName}_system_prompt, 
  ${outputName}_model, 
  ${outputName}_max_tokens, 
  ${outputName}_temperature
), axis=1)
${outputName} = ${inputName}  # Set the modified DataFrame to the output variable
`;
        return code;
    }
}
_a = OpenAILookUp;
OpenAILookUp.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/ParquetFileInput.js":
/*!********************************************!*\
  !*** ./lib/components/ParquetFileInput.js ***!
  \********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ParquetFileInput: () => (/* binding */ ParquetFileInput)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class ParquetFileInput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Parquet File Input";
        this._id = "parquetFileInput";
        this._type = "pandas_df_input";
        this._category = "input";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.fileTextIcon;
        this._default = {};
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "file",
                    label: "File path",
                    id: "filePath",
                    placeholder: "Type file name",
                    validation: "\\.(parquet)$",
                    validationMessage: "This field expects a file with a .parquet extension such as input.parquet."
                },
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderHandle, {
            type: ParquetFileInput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_1__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_1__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: ParquetFileInput.Name,
            ConfigForm: ParquetFileInput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: ParquetFileInput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport,
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd", "import pyarrow"];
    }
    generateComponentCode({ config, outputName }) {
        // Generate the Python code
        const code = `
# Reading data from ${config.filePath}
${outputName} = pd.read_parquet("${config.filePath}").convert_dtypes()
`;
        return code;
    }
}
_a = ParquetFileInput;
ParquetFileInput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/ParquetFileOutput.js":
/*!*********************************************!*\
  !*** ./lib/components/ParquetFileOutput.js ***!
  \*********************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   ParquetFileOutput: () => (/* binding */ ParquetFileOutput)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class ParquetFileOutput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Parquet File Output";
        this._id = "parquetFileOutput";
        this._type = "pandas_df_output";
        this._category = "output";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.filePlusIcon;
        this._default = { parquetOptions: { compression: "snappy" } }; // No default options for Parquet as of now
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "file",
                    label: "File path",
                    id: "filePath",
                    placeholder: "Type file name",
                    validation: "\\.(parquet)$",
                    validationMessage: "This field expects a file with a .parquet extension such as output.parquet."
                },
                {
                    type: "radio",
                    label: "Compression",
                    id: "parquetOptions.compression",
                    options: [
                        { value: "snappy", label: "Snappy" },
                        { value: "gzip", label: "GZip" },
                        { value: "brotli", label: "Brotli" },
                        { value: "None", label: "None" }
                    ],
                    advanced: true
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderHandle, {
            type: ParquetFileOutput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_1__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_1__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: ParquetFileOutput.Name,
            ConfigForm: ParquetFileOutput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: ParquetFileOutput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, inputName }) {
        let optionsString = Object.entries(config.parquetOptions || {})
            .filter(([key, value]) => value !== null && value !== '')
            .map(([key, value]) => `${key}="${value}"`)
            .join(', ');
        // Add comma only if optionsString is not empty
        optionsString = optionsString ? `, ${optionsString}` : '';
        const code = `
${inputName}.to_parquet("${config.filePath}"${optionsString})
`;
        return code;
    }
}
_a = ParquetFileOutput;
ParquetFileOutput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/PdfFileInput.js":
/*!****************************************!*\
  !*** ./lib/components/PdfFileInput.js ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   PdfFileInput: () => (/* binding */ PdfFileInput)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class PdfFileInput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = 'PDF File Input';
        this._id = 'pdfInput';
        this._type = 'pandas_df_input';
        this._fileDrop = ["pdf"];
        this._category = 'input';
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.fileTextIcon;
        this._default = { strategy: "fast" };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "file",
                    label: "File path",
                    id: "filePath",
                    placeholders: "Select or type file",
                    validation: "\\.(pdf)$",
                    validationMessage: "This field expects a file with a pdf extension such as file.pdf."
                },
                {
                    type: "select",
                    label: "Strategy",
                    id: "strategy",
                    options: [
                        { value: "fast", label: "Fast" }
                    ]
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderHandle, {
            type: PdfFileInput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_1__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_1__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: PdfFileInput.Name,
            ConfigForm: PdfFileInput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: PdfFileInput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideDependencies({ config }) {
        let deps = [];
        deps.push('pdf2image');
        deps.push('pdfminer.six');
        deps.push('pillow_heif');
        deps.push('opencv-python');
        deps.push('pikepdf');
        return deps;
    }
    provideImports({ config }) {
        let imports = [];
        imports.push('import pandas as pd');
        imports.push('from unstructured.partition.pdf import partition_pdf');
        imports.push('from unstructured.staging.base import convert_to_dataframe');
        return imports;
    }
    generateComponentCode({ config, outputName }) {
        let code = '';
        // Initial code for loading HTML
        code += `
# Read PDF and retrieve text from ${config.filePath}
${outputName}_elements = partition_pdf(
  filename="${config.filePath}",
  strategy="${config.strategy}",
  extract_images_in_pdf=False
)
${outputName} = convert_to_dataframe(${outputName}_elements)
`;
        return code;
    }
}
_a = PdfFileInput;
PdfFileInput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/RedditInput.js":
/*!***************************************!*\
  !*** ./lib/components/RedditInput.js ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   RedditInput: () => (/* binding */ RedditInput)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class RedditInput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Reddit Input";
        this._id = "redditInput";
        this._type = "pandas_df_input";
        this._category = "input.API";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.redditIcon; // Placeholder for the Reddit icon
        this._default = { submission: "all", limit: 20, sort: "hot", userAgent: "Sumbission extraction by Amphi" };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "input",
                    label: "Submission",
                    id: "submission",
                    placeholder: "URL or id",
                },
                {
                    type: "input",
                    label: "Limit",
                    id: "limit",
                    placeholder: "Number of posts to fetch",
                    advanced: true
                },
                {
                    type: "input",
                    label: "Client ID",
                    id: "clientId",
                    placeholder: "Reddit Client ID",
                    advanced: true
                },
                {
                    type: "input",
                    label: "Secret ID",
                    id: "secretId",
                    placeholder: "Reddit Secret ID",
                    advanced: true
                },
                {
                    type: "input",
                    label: "User Agent",
                    id: "userAgent",
                    placeholder: "Sumbission extraction by username",
                    advanced: true
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: RedditInput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: RedditInput.Name,
            ConfigForm: RedditInput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: RedditInput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd", "import praw", "from praw.models import MoreComments"];
    }
    generateComponentCode({ config, outputName }) {
        const submission = config.submission;
        const limit = config.limit || 10;
        // Check if the subreddit is a URL or an ID
        const isUrl = submission.startsWith('http') || submission.startsWith('www');
        const submissionAccess = isUrl
            ? `${outputName}_submission = ${outputName}_reddit.submission(url="${submission}")`
            : `${outputName}_submission = ${outputName}_reddit.submission("${submission}")`;
        const code = `
${outputName}_reddit = praw.Reddit(client_id="${config.clientId}", client_secret="${config.secretId}", user_agent="${config.userAgent}")
${submissionAccess}

${outputName}_comments_data = []
${outputName}_submission.comments.replace_more(limit=${limit})
for comment in ${outputName}_submission.comments.list():
    ${outputName}_comments_data.append({
        "comment_id": comment.id,
        "comment_body": comment.body,
        "comment_author": comment.author.name if comment.author else None,
        "comment_score": comment.score,
        "comment_created_utc": comment.created_utc,
        "parent_id": comment.parent_id
    })

${outputName} = pd.DataFrame(${outputName}_comments_data)
`;
        return code;
    }
}
_a = RedditInput;
RedditInput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/RenameColumns.js":
/*!*****************************************!*\
  !*** ./lib/components/RenameColumns.js ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   RenameColumns: () => (/* binding */ RenameColumns)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class RenameColumns extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Rename Columns";
        this._id = "rename";
        this._type = "pandas_df_processor";
        this._category = "transform";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.editIcon;
        this._default = {};
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "keyvalueColumns",
                    label: "Columns",
                    id: "columns",
                    placeholders: { key: "column name", value: "new column name" },
                    advanced: true
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: RenameColumns.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: RenameColumns.Name,
            ConfigForm: RenameColumns.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: RenameColumns.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, inputName, outputName }) {
        let columnsParam = "{";
        if (config.columns && config.columns.length > 0) {
            columnsParam += config.columns.map(column => {
                if (column.key.named) {
                    // Handle named columns as strings
                    return `"${column.key.value}": "${column.value}"`;
                }
                else {
                    // Handle unnamed (numeric index) columns, converting them to strings
                    return `${column.key.value}: "${column.value}"`;
                }
            }).join(", ");
            columnsParam += "}";
        }
        else {
            columnsParam = "{}"; // Ensure columnsParam is always initialized
        }
        // Template for the pandas rename columns code, explicitly setting axis='columns'
        const code = `
# Rename columns
${outputName} = ${inputName}.rename(columns=${columnsParam})
`;
        return code;
    }
}
_a = RenameColumns;
RenameColumns.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/RestInput.js":
/*!*************************************!*\
  !*** ./lib/components/RestInput.js ***!
  \*************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   RestInput: () => (/* binding */ RestInput)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class RestInput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "REST Input";
        this._id = "restInput";
        this._type = "pandas_df_input";
        this._category = "input.API";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.apiIcon;
        this._default = { method: "GET", headers: [] };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "input",
                    label: "URL",
                    id: "url",
                    placeholder: "Endpoint URL",
                },
                {
                    type: "radio",
                    label: "Method",
                    id: "method",
                    options: [
                        { value: "GET", label: "GET" },
                        { value: "PUT", label: "PUT" },
                        { value: "POST", label: "POST" },
                        { value: "DELETE", label: "DELETE" }
                    ],
                    advanced: true
                },
                {
                    type: "keyvalue",
                    label: "Headers",
                    id: "headers",
                    advanced: true
                },
                {
                    type: "textarea",
                    label: "Body",
                    id: "body",
                    placeholder: "Write body in JSON",
                    advanced: true
                },
                {
                    type: "input",
                    label: "JSON Path",
                    id: "jsonPath",
                    placeholder: "JSON Path to retrieve from response",
                    advanced: true
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: RestInput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: RestInput.Name,
            ConfigForm: RestInput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: RestInput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd", "import json", "import requests", "from jsonpath_ng import parse"];
    }
    generateComponentCode({ config, outputName }) {
        let bodyParam = '';
        if (config.body && config.body.trim() !== '') {
            // JSON body as a Python dictionary
            bodyParam = `json=${config.body.trim()}, `;
        }
        let headersParam = '';
        if (config.headers && config.headers.length > 0) {
            headersParam = 'headers={' + config.headers.map(header => `"${header.key}": "${header.value}"`).join(', ') + '}, ';
        }
        let jsonPathParam = '';
        if (config.jsonPath && config.jsonPath.trim() !== '') {
            jsonPathParam = `jsonpath_expr = parse('${config.jsonPath}')\nselected_data = [match.value for match in jsonpath_expr.find(data)] if jsonpath_expr.find(data) else []\n${outputName} = pd.DataFrame(selected_data).convert_dtypes() if selected_data else pd.DataFrame()\n`;
        }
        else {
            jsonPathParam = `${outputName} = pd.DataFrame([data]).convert_dtypes() if isinstance(data, dict) else pd.DataFrame(data).convert_dtypes()\n`;
        }
        const params = `${headersParam}${bodyParam}`;
        const trimmedParams = params.endsWith(', ') ? params.slice(0, -2) : params; // Remove trailing comma and space if present
        const code = `
import requests
from jsonpath_ng import parse
response = requests.request(
  method="${config.method}",
  url="${config.url}"${trimmedParams ? ', ' + trimmedParams : ''}
)
data = response.json()
${jsonPathParam}
`;
        return code;
    }
}
_a = RestInput;
RestInput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/Sample.js":
/*!**********************************!*\
  !*** ./lib/components/Sample.js ***!
  \**********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Sample: () => (/* binding */ Sample)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class Sample extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Sample Datasets";
        this._id = "sample";
        this._type = "pandas_df_processor";
        this._category = "transform";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.randomIcon;
        this._default = { mode: "random" };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "inputNumber",
                    label: "Rows number",
                    id: "rows",
                    placeholder: "0",
                    min: 0
                },
                {
                    type: "radio",
                    label: "Mode",
                    id: "mode",
                    options: [
                        { value: "random", label: "Random" },
                        { value: "head", label: "First" },
                        { value: "tail", label: "Last" }
                    ],
                    advanced: true
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: Sample.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: Sample.Name,
            ConfigForm: Sample.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: Sample.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, inputName, outputName }) {
        let sampleCode = "";
        if (config.mode === "random") {
            sampleCode = `${outputName} = ${inputName}.sample(n=${config.rows})`;
        }
        else if (config.mode === "tail") {
            sampleCode = `${outputName} = ${inputName}.tail(${config.rows})`;
        }
        else if (config.mode === "head") {
            sampleCode = `${outputName} = ${inputName}.head(${config.rows})`;
        }
        // Template for the pandas query code
        const code = `
${sampleCode}
`;
        return code;
    }
}
_a = Sample;
Sample.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/Sort.js":
/*!********************************!*\
  !*** ./lib/components/Sort.js ***!
  \********************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Sort: () => (/* binding */ Sort)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class Sort extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Sort Rows";
        this._id = "sort";
        this._type = "pandas_df_processor";
        this._category = "transform";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.sortIcon; // You should define this icon in your icons file
        this._default = { order: "True" };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "columns",
                    label: "Columns",
                    id: "by",
                    placeholder: "Select columns",
                },
                {
                    type: "radio",
                    label: "Order",
                    id: "order",
                    options: [
                        { value: "True", label: "Asc." },
                        { value: "False", label: "Desc." }
                    ],
                },
                {
                    type: "boolean",
                    label: "Ignore Index",
                    id: "ignoreIndex",
                    advanced: true
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderHandle, {
            type: Sort.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_1__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_1__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: Sort.Name,
            ConfigForm: Sort.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: Sort.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, inputName, outputName }) {
        const byColumns = `by=[${config.by.map(column => column.named ? `"${column.value}"` : column.value).join(", ")}]`;
        const ascending = typeof config.order !== "undefined" ? `, ascending=${config.order}` : "";
        const ignoreIndex = config.ignoreIndex ? `, ignore_index=${config.ignoreIndex}` : "";
        const code = `
# Sort rows 
${outputName} = ${inputName}.sort_values(${byColumns}${ascending}${ignoreIndex})
`;
        return code;
    }
}
_a = Sort;
Sort.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/SplitColumn.js":
/*!***************************************!*\
  !*** ./lib/components/SplitColumn.js ***!
  \***************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   SplitColumn: () => (/* binding */ SplitColumn)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class SplitColumn extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Split Column";
        this._id = "splitColumn";
        this._type = "pandas_df_processor";
        this._category = "transform";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.splitIcon;
        this._default = { keepOriginalColumn: false };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "column",
                    label: "Column",
                    id: "column",
                    placeholder: "Type column name",
                },
                {
                    type: "selectCustomizable",
                    label: "Delimiter",
                    id: "delimiter",
                    placeholder: "Select or type delimiter",
                    options: [
                        { value: ",", label: "comma (,)" },
                        { value: ";", label: "semicolon (;)" },
                        { value: " ", label: "space" },
                        { value: "  ", label: "tab" },
                        { value: "|", label: "pipe (|)" }
                    ],
                },
                {
                    type: "boolean",
                    label: "Keep original column",
                    id: "keepOriginalColumn",
                    advanced: true
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: SplitColumn.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: SplitColumn.Name,
            ConfigForm: SplitColumn.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: SplitColumn.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, inputName, outputName }) {
        const columnName = config.column.value; // name of the column
        const columnType = config.column.type; // current type of the column (e.g., 'int', 'string')
        const columnNamed = config.column.named; // boolean, true if column is named, false if index is used
        // Ensure unique variable names for intermediate dataframes
        const uniqueSplitVar = `${outputName}_split`;
        const uniqueCombinedVar = `${outputName}_combined`;
        // Start generating the code string
        let code = `\n# Create a new DataFrame from the split operation\n`;
        // Handling column access based on whether it's named or indexed
        const columnAccess = columnNamed ? `"${columnName}"` : columnName;
        // Convert column to string if it's not already
        if (columnType !== "string") {
            code += `${inputName}[${columnAccess}] = ${inputName}[${columnAccess}].astype("string")\n`;
        }
        // Split operation
        code += `${uniqueSplitVar} = ${inputName}[${columnAccess}].str.split("${config.delimiter}", expand=True)\n`;
        // Rename the new columns to avoid any potential overlap
        code += `${uniqueSplitVar}.columns  = [f"${columnName}_{i}" for i in range(${uniqueSplitVar}.shape[1])]\n`;
        // Combine the original DataFrame with the new columns
        code += `${outputName} = pd.concat([${inputName}, ${uniqueSplitVar}], axis=1)\n`;
        // Check if the original column should be kept
        if (!config.keepOriginalColumn) {
            code += `\n# Remove the original column used for split\n`;
            code += `${outputName}.drop(columns=[${columnAccess}], inplace=True)\n`;
        }
        // Assign to output
        return code;
    }
}
_a = SplitColumn;
SplitColumn.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/SqlQuery.js":
/*!************************************!*\
  !*** ./lib/components/SqlQuery.js ***!
  \************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   SQLQuery: () => (/* binding */ SQLQuery)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class SQLQuery extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "SQL Query";
        this._id = "sqlQuery";
        this._type = "pandas_df_processor";
        this._category = "transform";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.boxIcon;
        this._default = { query: "SELECT * FROM input_df1" };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "codeTextarea",
                    label: "SQL",
                    mode: "sql",
                    id: "query",
                    placeholder: "Enter your SQL Query here. Table is named input_df1.",
                    advanced: true
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: SQLQuery.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: SQLQuery.Name,
            ConfigForm: SQLQuery.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: SQLQuery.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd", "import duckdb"];
    }
    generateComponentCode({ config, inputName, outputName }) {
        // Template for the pandas query code, with backticks around column names
        const code = `
# Execute SQL Query using DuckDB
${outputName} = duckdb.query("${config.query.replace('input_df1', inputName)}").to_df().convert_dtypes()\n
`;
        return code;
    }
}
_a = SQLQuery;
SQLQuery.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/TypeConverter.js":
/*!*****************************************!*\
  !*** ./lib/components/TypeConverter.js ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   TypeConverter: () => (/* binding */ TypeConverter)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class TypeConverter extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = "Type Converter";
        this._id = "typeConverter";
        this._type = "pandas_df_processor";
        this._category = "transform";
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.typeIcon;
        this._default = { dataType: "string" };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "column",
                    label: "Column name",
                    id: "column",
                    placeholder: "Column name",
                },
                {
                    type: "cascader",
                    label: "Data Type to convert to",
                    id: "dataType",
                    placeholder: "Select ...",
                    options: [
                        {
                            value: "numeric",
                            label: "Numeric",
                            children: [
                                {
                                    value: "int",
                                    label: "Integer",
                                    children: [
                                        { value: "int64", label: "int64: Standard integer type." },
                                        { value: "int32", label: "int32: For optimized memory usage." },
                                        { value: "int16", label: "int16: For more optimized memory usage." },
                                        { value: "int8", label: "int8: For more optimized memory usage." },
                                        { value: "uint64", label: "uint64: Unsigned integer (can only hold non-negative values)" },
                                        { value: "uint32", label: "uint32: For more optimized memory usage." },
                                        { value: "uint16", label: "uint16: For more optimized memory usage." },
                                        { value: "uint8", label: "uint8: For more optimized memory usage." }
                                    ]
                                },
                                {
                                    value: "float",
                                    label: "Float",
                                    children: [
                                        { value: "float64", label: "float64: Standard floating-point type." },
                                        { value: "float32", label: "float32: For optimized memory usage." },
                                        { value: "float16", label: "float16: For optimized memory usage." }
                                    ]
                                }
                            ]
                        },
                        {
                            value: "text",
                            label: "Text",
                            children: [
                                { value: "string", label: "string: For string data. (recommended)" },
                                { value: "object", label: "object: For generic objects (strings, timestamps, mixed types)." },
                                { value: "category", label: "category: For categorical variables." }
                            ]
                        },
                        {
                            value: "datetime",
                            label: "Date & Time",
                            children: [
                                { value: "datetime64[ns]", label: "datetime64[ns]: For datetime values." },
                                { value: "datetime64[ms]", label: "datetime64[ms]: For datetime values in milliseconds." },
                                { value: "datetime64[s]", label: "datetime64[s]: For datetime values in seconds." },
                                { value: "datetime32[ns]", label: "datetime32[ns]: For compact datetime storage in nanoseconds." },
                                { value: "datetime32[ms]", label: "datetime32[ms]: For compact datetime storage in milliseconds." },
                                { value: "timedelta[ns]", label: "timedelta[ns]: For differences between two datetimes." }
                            ]
                        },
                        {
                            value: "boolean",
                            label: "Boolean",
                            children: [
                                { value: "bool", label: "bool: For boolean values (True or False)." }
                            ]
                        }
                    ]
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_2__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        // Create the handle element
        const handleElement = react__WEBPACK_IMPORTED_MODULE_1___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderHandle, {
            type: TypeConverter.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_2__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_2__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: TypeConverter.Name,
            ConfigForm: TypeConverter.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: TypeConverter.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import pandas as pd"];
    }
    generateComponentCode({ config, inputName, outputName }) {
        const columnName = config.column.value;
        const columnType = config.column.type;
        const columnNamed = config.column.named;
        const dataType = config.dataType[config.dataType.length - 1];
        let code = `# Initialize the output DataFrame\n`;
        code += `${outputName} = ${inputName}.copy()\n`;
        code += `# Convert ${columnName} from ${columnType} to ${dataType}\n`;
        code += this.generateConversionCode(inputName, outputName, columnName, columnType, dataType, columnNamed);
        return code;
    }
    generateConversionCode(inputName, outputName, columnName, columnType, dataType, columnNamed) {
        let conversionFunction;
        let additionalParams = "";
        if (dataType.startsWith("datetime")) {
            if (dataType.includes("[")) {
                const unit = dataType.split("[")[1].split("]")[0];
                additionalParams = `, unit="${unit}"`;
            }
            conversionFunction = `pd.to_datetime`;
        }
        else if (columnType.startsWith("float") && dataType.startsWith("int")) {
            conversionFunction = `${inputName}["${columnName}"].astype("float").fillna(0).astype("${dataType}")`;
            if (columnNamed) {
                return `${outputName}["${columnName}"] = ${conversionFunction}\n`;
            }
            else {
                return `${outputName}.iloc[:, ${columnName}] = ${conversionFunction}\n`;
            }
        }
        else {
            conversionFunction = `astype("${dataType}")`;
        }
        if (columnNamed) {
            return `${outputName}["${columnName}"] = ${inputName}["${columnName}"].${conversionFunction}${additionalParams}\n`;
        }
        else {
            return `${outputName}.iloc[:, ${columnName}] = ${inputName}.iloc[:, ${columnName}].${conversionFunction}${additionalParams}\n`;
        }
    }
}
_a = TypeConverter;
TypeConverter.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_1__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_1__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_1___default().createElement((react__WEBPACK_IMPORTED_MODULE_1___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/XmlFileInput.js":
/*!****************************************!*\
  !*** ./lib/components/XmlFileInput.js ***!
  \****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   XmlFileInput: () => (/* binding */ XmlFileInput)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;



 // Ensure you have an appropriate XML icon
class XmlFileInput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = 'XML File Input';
        this._id = 'xmlFileInput';
        this._type = 'pandas_df_input';
        this._fileDrop = ["xml"];
        this._category = 'input';
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.fileTextIcon;
        this._default = { xmlOptions: { xpath: '' } };
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "file",
                    label: "File path",
                    id: "filePath",
                    placeholder: "Type file name",
                    validation: "\\.xml$",
                    validationMessage: "This field expects a file with an xml extension such as input.xml."
                },
                {
                    type: "text",
                    label: "XPath Expression",
                    id: "xmlOptions.xpath",
                    placeholder: "/root/child"
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        const handleElement = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderHandle, {
            type: XmlFileInput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_1__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_1__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: XmlFileInput.Name,
            ConfigForm: XmlFileInput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: XmlFileInput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        return ["import xml.etree.ElementTree as ET"]; // Adjust import based on XML parsing library
    }
    generateComponentCode({ config, outputName }) {
        // Ensure unique variable names based on the outputName for tree and root
        const treeVar = `${outputName}_tree`;
        const rootVar = `${outputName}_root`;
        let xpathOption = config.xmlOptions.xpath ? `"${config.xmlOptions.xpath}"` : "'.'"; // Use the provided XPath or default to root
        const code = `
${treeVar} = ET.parse("${config.filePath}")
${rootVar} = ${treeVar}.getroot()
${outputName} = ${rootVar}.findall(${xpathOption})
    `;
        return code;
    }
}
_a = XmlFileInput;
XmlFileInput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/components/XmlFileOutput.js":
/*!*****************************************!*\
  !*** ./lib/components/XmlFileOutput.js ***!
  \*****************************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   XmlFileOutput: () => (/* binding */ XmlFileOutput)
/* harmony export */ });
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! react */ "webpack/sharing/consume/default/react");
/* harmony import */ var react__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(react__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! reactflow */ "webpack/sharing/consume/default/reactflow/reactflow");
/* harmony import */ var reactflow__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(reactflow__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _icons__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../icons */ "./lib/icons.js");
var _a;




class XmlFileOutput extends (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.PipelineComponent)() {
    constructor() {
        super(...arguments);
        this._name = 'XML File Output';
        this._id = 'xmlFileOutput';
        this._type = 'pandas_df_output'; // Adjust if necessary for your data structure
        this._category = 'output';
        this._icon = _icons__WEBPACK_IMPORTED_MODULE_3__.filePlusIcon;
        this._default = {}; // Default options for XML output can be defined here
        this._form = {
            idPrefix: "component__form",
            fields: [
                {
                    type: "file",
                    label: "File path",
                    id: "filePath",
                    placeholder: "Type file name",
                    validation: "\\.xml$",
                    validationMessage: "This field expects a file with an xml extension such as output.xml."
                }
            ],
        };
    }
    UIComponent({ id, data, context, componentService, manager, commands }) {
        const { setNodes, deleteElements, setViewport } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useReactFlow)();
        const store = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStoreApi)();
        const deleteNode = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
            deleteElements({ nodes: [{ id }] });
        }, [id, deleteElements]);
        const zoomSelector = (s) => s.transform[2] >= 1;
        const showContent = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(zoomSelector);
        const selector = (s) => ({
            nodeInternals: s.nodeInternals,
            edges: s.edges,
        });
        const { nodeInternals, edges } = (0,reactflow__WEBPACK_IMPORTED_MODULE_1__.useStore)(selector);
        const nodeId = id;
        const internals = { nodeInternals, edges, nodeId };
        const handleElement = react__WEBPACK_IMPORTED_MODULE_0___default().createElement(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderHandle, {
            type: XmlFileOutput.Type,
            Handle: reactflow__WEBPACK_IMPORTED_MODULE_1__.Handle,
            Position: reactflow__WEBPACK_IMPORTED_MODULE_1__.Position,
            internals: internals
        });
        return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.renderComponentUI)({
            id: id,
            data: data,
            context: context,
            manager: manager,
            commands: commands,
            name: XmlFileOutput.Name,
            ConfigForm: XmlFileOutput.ConfigForm({ nodeId: id, data, context, componentService, manager, commands, store, setNodes }),
            Icon: XmlFileOutput.Icon,
            showContent: showContent,
            handle: handleElement,
            deleteNode: deleteNode,
            setViewport: setViewport
        })));
    }
    provideImports({ config }) {
        // Adjust this based on the XML library you choose to use for output
        return ["import xml.etree.ElementTree as ET", "import pandas as pd"]; // Adjust if pandas isn't required
    }
    generateComponentCode({ config, inputName }) {
        // Create unique variable names based on the inputName for the XML output
        const xmlOutputVar = `${inputName}_xml_output`;
        const fileVar = `${inputName}_file`;
        const code = `
# Output the XML content to a file
${xmlOutputVar} = ${inputName}.to_xml()
with open("${config.filePath}", "w") as ${fileVar}:
    ${fileVar}.write(${xmlOutputVar})
`;
        return code;
    }
}
_a = XmlFileOutput;
XmlFileOutput.ConfigForm = ({ nodeId, data, context, componentService, manager, commands, store, setNodes }) => {
    const defaultConfig = _a.Default; // Define your default config
    const handleSetDefaultConfig = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)(() => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.setDefaultConfig)({ nodeId, store, setNodes, defaultConfig });
    }, [nodeId, store, setNodes, defaultConfig]);
    (0,react__WEBPACK_IMPORTED_MODULE_0__.useEffect)(() => {
        handleSetDefaultConfig();
    }, [handleSetDefaultConfig]);
    const handleChange = (0,react__WEBPACK_IMPORTED_MODULE_0__.useCallback)((evtTargetValue, field) => {
        (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.onChange)({ evtTargetValue, field, nodeId, store, setNodes });
    }, [nodeId, store, setNodes]);
    return (react__WEBPACK_IMPORTED_MODULE_0___default().createElement((react__WEBPACK_IMPORTED_MODULE_0___default().Fragment), null, (0,_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_2__.generateUIFormComponent)({
        nodeId: nodeId,
        type: _a.Type,
        name: _a.Name,
        form: _a.Form,
        data: data,
        context: context,
        componentService: componentService,
        manager: manager,
        commands: commands,
        handleChange: handleChange,
    })));
};



/***/ }),

/***/ "./lib/icons.js":
/*!**********************!*\
  !*** ./lib/icons.js ***!
  \**********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   aggregateIcon: () => (/* binding */ aggregateIcon),
/* harmony export */   annotationIcon: () => (/* binding */ annotationIcon),
/* harmony export */   apiIcon: () => (/* binding */ apiIcon),
/* harmony export */   boxIcon: () => (/* binding */ boxIcon),
/* harmony export */   codeIcon: () => (/* binding */ codeIcon),
/* harmony export */   crosshairIcon: () => (/* binding */ crosshairIcon),
/* harmony export */   dedupIcon: () => (/* binding */ dedupIcon),
/* harmony export */   editIcon: () => (/* binding */ editIcon),
/* harmony export */   expandIcon: () => (/* binding */ expandIcon),
/* harmony export */   extractIcon: () => (/* binding */ extractIcon),
/* harmony export */   filePlusIcon: () => (/* binding */ filePlusIcon),
/* harmony export */   fileTextIcon: () => (/* binding */ fileTextIcon),
/* harmony export */   filterIcon: () => (/* binding */ filterIcon),
/* harmony export */   globeIcon: () => (/* binding */ globeIcon),
/* harmony export */   googleSheetsIcon: () => (/* binding */ googleSheetsIcon),
/* harmony export */   mergeIcon: () => (/* binding */ mergeIcon),
/* harmony export */   monitorIcon: () => (/* binding */ monitorIcon),
/* harmony export */   mySQLIcon: () => (/* binding */ mySQLIcon),
/* harmony export */   openAiIcon: () => (/* binding */ openAiIcon),
/* harmony export */   randomIcon: () => (/* binding */ randomIcon),
/* harmony export */   redditIcon: () => (/* binding */ redditIcon),
/* harmony export */   settingsIcon: () => (/* binding */ settingsIcon),
/* harmony export */   sortIcon: () => (/* binding */ sortIcon),
/* harmony export */   splitIcon: () => (/* binding */ splitIcon),
/* harmony export */   typeIcon: () => (/* binding */ typeIcon)
/* harmony export */ });
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @jupyterlab/ui-components */ "webpack/sharing/consume/default/@jupyterlab/ui-components");
/* harmony import */ var _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _style_icons_file_text_24_svg__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ../style/icons/file-text-24.svg */ "./style/icons/file-text-24.svg");
/* harmony import */ var _style_icons_file_plus_24_svg__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ../style/icons/file-plus-24.svg */ "./style/icons/file-plus-24.svg");
/* harmony import */ var _style_icons_monitor_24_svg__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ../style/icons/monitor-24.svg */ "./style/icons/monitor-24.svg");
/* harmony import */ var _style_icons_outline_24_svg__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ../style/icons/outline-24.svg */ "./style/icons/outline-24.svg");
/* harmony import */ var _style_icons_api_24_svg__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ../style/icons/api-24.svg */ "./style/icons/api-24.svg");
/* harmony import */ var _style_icons_code_24_svg__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ../style/icons/code-24.svg */ "./style/icons/code-24.svg");
/* harmony import */ var _style_icons_filter_24_svg__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ../style/icons/filter-24.svg */ "./style/icons/filter-24.svg");
/* harmony import */ var _style_icons_collections_24_svg__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ../style/icons/collections-24.svg */ "./style/icons/collections-24.svg");
/* harmony import */ var _style_icons_network_alt_24_svg__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ../style/icons/network-alt-24.svg */ "./style/icons/network-alt-24.svg");
/* harmony import */ var _style_icons_duplicate_24_svg__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ../style/icons/duplicate-24.svg */ "./style/icons/duplicate-24.svg");
/* harmony import */ var _style_icons_crop_24_svg__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! ../style/icons/crop-24.svg */ "./style/icons/crop-24.svg");
/* harmony import */ var _style_icons_globe_24_svg__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ../style/icons/globe-24.svg */ "./style/icons/globe-24.svg");
/* harmony import */ var _style_icons_sort_desc_24_svg__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ../style/icons/sort-desc-24.svg */ "./style/icons/sort-desc-24.svg");
/* harmony import */ var _style_icons_edit_24_svg__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ../style/icons/edit-24.svg */ "./style/icons/edit-24.svg");
/* harmony import */ var _style_icons_type_24_svg__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ../style/icons/type-24.svg */ "./style/icons/type-24.svg");
/* harmony import */ var _style_icons_scissors_24_svg__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! ../style/icons/scissors-24.svg */ "./style/icons/scissors-24.svg");
/* harmony import */ var _style_icons_google_sheets_color_24_svg__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! ../style/icons/google-sheets-color-24.svg */ "./style/icons/google-sheets-color-24.svg");
/* harmony import */ var _style_icons_mysql_svg__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! ../style/icons/mysql.svg */ "./style/icons/mysql.svg");
/* harmony import */ var _style_icons_box_16_svg__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! ../style/icons/box-16.svg */ "./style/icons/box-16.svg");
/* harmony import */ var _style_icons_reddit_svg__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! ../style/icons/reddit.svg */ "./style/icons/reddit.svg");
/* harmony import */ var _style_icons_git_merge_24_svg__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ../style/icons/git-merge-24.svg */ "./style/icons/git-merge-24.svg");
/* harmony import */ var _style_icons_crosshair_24_svg__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! ../style/icons/crosshair-24.svg */ "./style/icons/crosshair-24.svg");
/* harmony import */ var _style_icons_random_24_svg__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! ../style/icons/random-24.svg */ "./style/icons/random-24.svg");
/* harmony import */ var _style_icons_openai_svg__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! ../style/icons/openai.svg */ "./style/icons/openai.svg");
/* harmony import */ var _style_icons_settings_16_svg__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! ../style/icons/settings-16.svg */ "./style/icons/settings-16.svg");


























const fileTextIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:file-text-icon',
    svgstr: _style_icons_file_text_24_svg__WEBPACK_IMPORTED_MODULE_1__
});
const filePlusIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:file-plus-icon',
    svgstr: _style_icons_file_plus_24_svg__WEBPACK_IMPORTED_MODULE_2__
});
const monitorIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:monitor-icon',
    svgstr: _style_icons_monitor_24_svg__WEBPACK_IMPORTED_MODULE_3__
});
const annotationIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:annotation-icon',
    svgstr: _style_icons_outline_24_svg__WEBPACK_IMPORTED_MODULE_4__
});
const apiIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:api-icon',
    svgstr: _style_icons_api_24_svg__WEBPACK_IMPORTED_MODULE_5__
});
const codeIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:code-icon',
    svgstr: _style_icons_code_24_svg__WEBPACK_IMPORTED_MODULE_6__
});
const filterIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:filter-icon',
    svgstr: _style_icons_filter_24_svg__WEBPACK_IMPORTED_MODULE_7__
});
const aggregateIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:aggregateIcon',
    svgstr: _style_icons_collections_24_svg__WEBPACK_IMPORTED_MODULE_8__
});
const mergeIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:mergeIcon',
    svgstr: _style_icons_git_merge_24_svg__WEBPACK_IMPORTED_MODULE_9__
});
const expandIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:expandIcon',
    svgstr: _style_icons_network_alt_24_svg__WEBPACK_IMPORTED_MODULE_10__
});
const dedupIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:dedupIcon',
    svgstr: _style_icons_duplicate_24_svg__WEBPACK_IMPORTED_MODULE_11__
});
const globeIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:globeIcon',
    svgstr: _style_icons_globe_24_svg__WEBPACK_IMPORTED_MODULE_12__
});
const sortIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:sortIcon',
    svgstr: _style_icons_sort_desc_24_svg__WEBPACK_IMPORTED_MODULE_13__
});
const editIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:editIcon',
    svgstr: _style_icons_edit_24_svg__WEBPACK_IMPORTED_MODULE_14__
});
const typeIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:typeIcon',
    svgstr: _style_icons_type_24_svg__WEBPACK_IMPORTED_MODULE_15__
});
const extractIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:extractIcon',
    svgstr: _style_icons_crop_24_svg__WEBPACK_IMPORTED_MODULE_16__
});
const splitIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:splitIcon',
    svgstr: _style_icons_scissors_24_svg__WEBPACK_IMPORTED_MODULE_17__
});
const googleSheetsIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:googleSheetsIcon',
    svgstr: _style_icons_google_sheets_color_24_svg__WEBPACK_IMPORTED_MODULE_18__
});
const mySQLIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:mySQLIcon',
    svgstr: _style_icons_mysql_svg__WEBPACK_IMPORTED_MODULE_19__
});
const boxIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:box-icon',
    svgstr: _style_icons_box_16_svg__WEBPACK_IMPORTED_MODULE_20__
});
const redditIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:redditIcon',
    svgstr: _style_icons_reddit_svg__WEBPACK_IMPORTED_MODULE_21__
});
const crosshairIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:crosshairIcon',
    svgstr: _style_icons_crosshair_24_svg__WEBPACK_IMPORTED_MODULE_22__
});
const randomIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:randomIcon',
    svgstr: _style_icons_random_24_svg__WEBPACK_IMPORTED_MODULE_23__
});
const openAiIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:openAiIcon',
    svgstr: _style_icons_openai_svg__WEBPACK_IMPORTED_MODULE_24__
});
const settingsIcon = new _jupyterlab_ui_components__WEBPACK_IMPORTED_MODULE_0__.LabIcon({
    name: 'amphi:settings-config-icon',
    svgstr: _style_icons_settings_16_svg__WEBPACK_IMPORTED_MODULE_25__
});


/***/ }),

/***/ "./lib/index.js":
/*!**********************!*\
  !*** ./lib/index.js ***!
  \**********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! @amphi/pipeline-components-manager */ "webpack/sharing/consume/default/@amphi/pipeline-components-manager");
/* harmony import */ var _amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! ./components */ "./lib/components/CsvFileInput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! ./components */ "./lib/components/JsonFileInput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_3__ = __webpack_require__(/*! ./components */ "./lib/components/ExcelFileInput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_4__ = __webpack_require__(/*! ./components */ "./lib/components/RestInput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_5__ = __webpack_require__(/*! ./components */ "./lib/components/ParquetFileInput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_6__ = __webpack_require__(/*! ./components */ "./lib/components/XmlFileInput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_7__ = __webpack_require__(/*! ./components */ "./lib/components/GoogleSheetsInput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_8__ = __webpack_require__(/*! ./components */ "./lib/components/MySQLInput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_9__ = __webpack_require__(/*! ./components */ "./lib/components/HtmlFileInput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_10__ = __webpack_require__(/*! ./components */ "./lib/components/PdfFileInput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_11__ = __webpack_require__(/*! ./components */ "./lib/components/RedditInput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_12__ = __webpack_require__(/*! ./components */ "./lib/components/FilterColumns.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_13__ = __webpack_require__(/*! ./components */ "./lib/components/RenameColumns.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_14__ = __webpack_require__(/*! ./components */ "./lib/components/Filter.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_15__ = __webpack_require__(/*! ./components */ "./lib/components/Aggregate.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_16__ = __webpack_require__(/*! ./components */ "./lib/components/Join.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_17__ = __webpack_require__(/*! ./components */ "./lib/components/TypeConverter.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_18__ = __webpack_require__(/*! ./components */ "./lib/components/SplitColumn.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_19__ = __webpack_require__(/*! ./components */ "./lib/components/Extract.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_20__ = __webpack_require__(/*! ./components */ "./lib/components/Sort.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_21__ = __webpack_require__(/*! ./components */ "./lib/components/Deduplicate.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_22__ = __webpack_require__(/*! ./components */ "./lib/components/ExpandList.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_23__ = __webpack_require__(/*! ./components */ "./lib/components/Sample.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_24__ = __webpack_require__(/*! ./components */ "./lib/components/SqlQuery.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_25__ = __webpack_require__(/*! ./components */ "./lib/components/CustomTransformations.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_26__ = __webpack_require__(/*! ./components */ "./lib/components/OpenAILookUp.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_27__ = __webpack_require__(/*! ./components */ "./lib/components/CsvFileOutput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_28__ = __webpack_require__(/*! ./components */ "./lib/components/JsonFileOutput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_29__ = __webpack_require__(/*! ./components */ "./lib/components/ExcelFileOutput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_30__ = __webpack_require__(/*! ./components */ "./lib/components/ParquetFileOutput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_31__ = __webpack_require__(/*! ./components */ "./lib/components/XmlFileOutput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_32__ = __webpack_require__(/*! ./components */ "./lib/components/GoogleSheetsOutput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_33__ = __webpack_require__(/*! ./components */ "./lib/components/MySQLOutput.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_34__ = __webpack_require__(/*! ./components */ "./lib/components/Console.js");
/* harmony import */ var _components__WEBPACK_IMPORTED_MODULE_35__ = __webpack_require__(/*! ./components */ "./lib/components/EnvVariables.js");


const plugin = {
    id: '@amphi/pipeline-components-core',
    description: 'Adds a step counter/button (1 of 3 related examples). This extension holds the UI/interface',
    autoStart: true,
    requires: [_amphi_pipeline_components_manager__WEBPACK_IMPORTED_MODULE_0__.ComponentManager],
    activate: (app, componentService) => {
        console.log('JupyterLab extension pipeline-components-core is activated!');
        // Input
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_1__.CsvFileInput.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_2__.JsonFileInput.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_3__.ExcelFileInput.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_4__.RestInput.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_5__.ParquetFileInput.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_6__.XmlFileInput.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_7__.GoogleSheetsInput.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_8__.MySQLInput.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_9__.HtmlFileInput.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_10__.PdfFileInput.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_11__.RedditInput.getInstance());
        // Processors
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_12__.FilterColumns.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_13__.RenameColumns.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_14__.Filter.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_15__.Aggregate.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_16__.Join.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_17__.TypeConverter.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_18__.SplitColumn.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_19__.Extract.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_20__.Sort.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_21__.Deduplicate.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_22__.ExpandList.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_23__.Sample.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_24__.SQLQuery.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_25__.CustomTransformations.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_26__.OpenAILookUp.getInstance());
        // Outputs
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_27__.CsvFileOutput.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_28__.JsonFileOutput.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_29__.ExcelFileOutput.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_30__.ParquetFileOutput.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_31__.XmlFileOutput.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_32__.GoogleSheetsOutput.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_33__.MySQLOutput.getInstance());
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_34__.Console.getInstance());
        // Other
        componentService.addComponent(_components__WEBPACK_IMPORTED_MODULE_35__.EnvVariables.getInstance());
        //componentService.addComponent(Annotation.getInstance())
        // componentService.addComponent(EmailLogger.getInstance())
        // componentService.addComponent(FileLogger.getInstance())
        // componentService.addComponent(RestInput.getInstance())
        /*
     componentService.addComponent(FileOutput.getInstance())
     componentService.addComponent(Console.getInstance())
     componentService.addComponent(CustomTransformations.getInstance())
     componentService.addComponent(Filter.getInstance())
     componentService.addComponent(LookUp.getInstance())
     */
    }
};
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (plugin);


/***/ }),

/***/ "./style/icons/api-24.svg":
/*!********************************!*\
  !*** ./style/icons/api-24.svg ***!
  \********************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><path fill=\"currentColor\" fill-rule=\"evenodd\" d=\"M2 5a3 3 0 115.585 1.524l1.79 1.79.68-.68a2.75 2.75 0 013.89 0l.68.68 1.79-1.79a3 3 0 111.06 1.06l-1.79 1.791.681.68a2.75 2.75 0 010 3.89l-.68.68 1.79 1.79a3 3 0 11-1.06 1.06l-1.791-1.79-.68.681a2.75 2.75 0 01-3.89 0l-.68-.68-1.79 1.79a3 3 0 11-1.06-1.06l1.79-1.791-.681-.68a2.75 2.75 0 010-3.89l.68-.68-1.79-1.79A3 3 0 012 5zm3-1.5a1.5 1.5 0 100 3 1.5 1.5 0 000-3zm0 14a1.5 1.5 0 100 3 1.5 1.5 0 000-3zM17.5 19a1.5 1.5 0 113 0 1.5 1.5 0 01-3 0zM19 3.5a1.5 1.5 0 100 3 1.5 1.5 0 000-3zm-7.884 5.195a1.25 1.25 0 011.768 0l2.421 2.421a1.25 1.25 0 010 1.768l-2.421 2.421a1.25 1.25 0 01-1.768 0l-2.421-2.421a1.25 1.25 0 010-1.768l2.421-2.421z\" clip-rule=\"evenodd\"/></svg>";

/***/ }),

/***/ "./style/icons/box-16.svg":
/*!********************************!*\
  !*** ./style/icons/box-16.svg ***!
  \********************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"16\" height=\"16\" fill=\"none\" viewBox=\"0 0 16 16\"><path fill=\"currentColor\" fill-rule=\"evenodd\" d=\"M6.98.678a2.25 2.25 0 012.04 0l5.297 2.696c.42.214.683.644.683 1.114v6.717c0 .658-.37 1.261-.956 1.56L9.02 15.322a2.25 2.25 0 01-2.042 0l-5.023-2.557A1.75 1.75 0 011 11.205V4.488c0-.47.264-.9.683-1.114L6.979.678zm1.36 1.337a.75.75 0 00-.68 0L3.224 4.273 8 6.661l4.776-2.388L8.34 2.015zm-5.84 9.19V5.588l4.75 2.375v5.814l-4.613-2.35a.25.25 0 01-.137-.222zm6.25 2.572l4.613-2.35a.25.25 0 00.137-.222V5.588L8.75 7.963v5.814z\" clip-rule=\"evenodd\"/></svg>";

/***/ }),

/***/ "./style/icons/code-24.svg":
/*!*********************************!*\
  !*** ./style/icons/code-24.svg ***!
  \*********************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><g fill=\"currentColor\"><path d=\"M14.447 3.026a.75.75 0 00-.92.527l-4.5 16.5a.75.75 0 001.447.394l4.5-16.5a.75.75 0 00-.527-.92zM16.207 6.232a.75.75 0 011.06-.025l5.5 5.25a.75.75 0 010 1.085l-5.5 5.25a.75.75 0 01-1.035-1.085L21.164 12l-4.932-4.707a.75.75 0 01-.024-1.06zM7.768 7.293a.75.75 0 00-1.036-1.086l-5.5 5.25a.75.75 0 000 1.085l5.5 5.25a.75.75 0 101.036-1.085L2.836 12l4.932-4.707z\"/></g></svg>";

/***/ }),

/***/ "./style/icons/collections-24.svg":
/*!****************************************!*\
  !*** ./style/icons/collections-24.svg ***!
  \****************************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><g fill=\"currentColor\"><path d=\"M5 6.75A.75.75 0 015.75 6h6.5a.75.75 0 010 1.5h-6.5A.75.75 0 015 6.75zM5.75 9a.75.75 0 000 1.5h4.5a.75.75 0 000-1.5h-4.5z\"/><path fill-rule=\"evenodd\" d=\"M1 4.75A2.75 2.75 0 013.75 2h10.5c.854 0 1.617.39 2.121 1h.879c.854 0 1.617.39 2.121 1h.879A2.75 2.75 0 0123 6.75v10.5A2.75 2.75 0 0120.25 20h-.879c-.504.61-1.267 1-2.121 1h-.879c-.504.61-1.267 1-2.121 1H3.75A2.75 2.75 0 011 19.25V4.75zM19.989 18.5h.261c.69 0 1.25-.56 1.25-1.25V6.75c0-.69-.56-1.25-1.25-1.25h-.261c.007.082.011.166.011.25v12.5c0 .084-.004.168-.011.25zM17 4.75c0-.084-.004-.168-.011-.25h.261c.69 0 1.25.56 1.25 1.25v12.5c0 .69-.56 1.25-1.25 1.25h-.261c.007-.082.011-.166.011-.25V4.75zM3.75 3.5c-.69 0-1.25.56-1.25 1.25v14.5c0 .69.56 1.25 1.25 1.25h10.5c.69 0 1.25-.56 1.25-1.25V4.75c0-.69-.56-1.25-1.25-1.25H3.75z\" clip-rule=\"evenodd\"/></g></svg>";

/***/ }),

/***/ "./style/icons/crop-24.svg":
/*!*********************************!*\
  !*** ./style/icons/crop-24.svg ***!
  \*********************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><path fill=\"currentColor\" fill-rule=\"evenodd\" d=\"M6.5 1.25a.75.75 0 00-1.5 0V5H1.25a.75.75 0 000 1.5H5v9.75A2.75 2.75 0 007.75 19h9.75v3.75a.75.75 0 001.5 0V19h3.75a.75.75 0 000-1.5H19V7.75A2.75 2.75 0 0016.25 5H6.5V1.25zm0 5.25v9.75a1.25 1.25 0 001.25 1.25h9.75V7.75a1.25 1.25 0 00-1.25-1.25H6.5z\" clip-rule=\"evenodd\"/></svg>";

/***/ }),

/***/ "./style/icons/crosshair-24.svg":
/*!**************************************!*\
  !*** ./style/icons/crosshair-24.svg ***!
  \**************************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><path fill=\"currentColor\" fill-rule=\"evenodd\" d=\"M1 12C1 5.925 5.925 1 12 1s11 4.925 11 11-4.925 11-11 11S1 18.075 1 12zm11.75 9.47v-2.72a.75.75 0 00-1.5 0v2.72a9.502 9.502 0 01-8.72-8.72h2.72a.75.75 0 000-1.5H2.53a9.502 9.502 0 018.72-8.72v2.72a.75.75 0 001.5 0V2.53a9.502 9.502 0 018.72 8.72h-2.72a.75.75 0 000 1.5h2.72a9.502 9.502 0 01-8.72 8.72z\" clip-rule=\"evenodd\"/></svg>";

/***/ }),

/***/ "./style/icons/duplicate-24.svg":
/*!**************************************!*\
  !*** ./style/icons/duplicate-24.svg ***!
  \**************************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><g fill=\"currentColor\"><path d=\"M3.75 1A2.75 2.75 0 001 3.75v10.5A2.75 2.75 0 003.75 17h1a.75.75 0 000-1.5h-1c-.69 0-1.25-.56-1.25-1.25V3.75c0-.69.56-1.25 1.25-1.25h10.5c.69 0 1.25.56 1.25 1.25v1a.75.75 0 001.5 0v-1A2.75 2.75 0 0014.25 1H3.75z\"/><path fill-rule=\"evenodd\" d=\"M9.75 7A2.75 2.75 0 007 9.75v10.5A2.75 2.75 0 009.75 23h10.5A2.75 2.75 0 0023 20.25V9.75A2.75 2.75 0 0020.25 7H9.75zM8.5 9.75c0-.69.56-1.25 1.25-1.25h10.5c.69 0 1.25.56 1.25 1.25v10.5c0 .69-.56 1.25-1.25 1.25H9.75c-.69 0-1.25-.56-1.25-1.25V9.75z\" clip-rule=\"evenodd\"/></g></svg>";

/***/ }),

/***/ "./style/icons/edit-24.svg":
/*!*********************************!*\
  !*** ./style/icons/edit-24.svg ***!
  \*********************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><g fill=\"currentColor\"><path fill-rule=\"evenodd\" d=\"M17.055 2.884a2.75 2.75 0 013.89 0l.171.171a2.75 2.75 0 010 3.89l-9.005 9.005A4.75 4.75 0 0110.516 17L6.28 18.696a.75.75 0 01-.975-.975l1.695-4.237a4.749 4.749 0 011.051-1.595l9.005-9.005zm2.829 1.06a1.25 1.25 0 00-1.768 0l-.555.556L19.5 6.44l.555-.556a1.25 1.25 0 000-1.768l-.171-.172zM18.439 7.5L16.5 5.56l-7.39 7.39a3.25 3.25 0 00-.719 1.09l-1.045 2.614 2.613-1.046a3.25 3.25 0 001.091-.719L18.44 7.5z\" clip-rule=\"evenodd\"/><path d=\"M3.75 4.5c-.69 0-1.25.56-1.25 1.25v14.5c0 .69.56 1.25 1.25 1.25h14.5c.69 0 1.25-.56 1.25-1.25V13a.75.75 0 011.5 0v7.25A2.75 2.75 0 0118.25 23H3.75A2.75 2.75 0 011 20.25V5.75A2.75 2.75 0 013.75 3H11a.75.75 0 010 1.5H3.75z\"/></g></svg>";

/***/ }),

/***/ "./style/icons/file-plus-24.svg":
/*!**************************************!*\
  !*** ./style/icons/file-plus-24.svg ***!
  \**************************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><g fill=\"currentColor\"><path d=\"M11.75 10.75a.75.75 0 01.75.75V14H15a.75.75 0 010 1.5h-2.5V18a.75.75 0 01-1.5 0v-2.5H8.5a.75.75 0 010-1.5H11v-2.5a.75.75 0 01.75-.75z\"/><path fill-rule=\"evenodd\" d=\"M5.75 1A2.75 2.75 0 003 3.75v16.5A2.75 2.75 0 005.75 23h12.5A2.75 2.75 0 0021 20.25V8.664c0-.464-.184-.909-.513-1.237l-5.914-5.914A1.75 1.75 0 0013.336 1H5.75zM4.5 3.75c0-.69.56-1.25 1.25-1.25H13v5.75c0 .414.336.75.75.75h5.75v11.25c0 .69-.56 1.25-1.25 1.25H5.75c-.69 0-1.25-.56-1.25-1.25V3.75zM18.44 7.5L14.5 3.56V7.5h3.94z\" clip-rule=\"evenodd\"/></g></svg>";

/***/ }),

/***/ "./style/icons/file-text-24.svg":
/*!**************************************!*\
  !*** ./style/icons/file-text-24.svg ***!
  \**************************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><g fill=\"currentColor\"><path d=\"M7.75 12a.75.75 0 000 1.5h8a.75.75 0 000-1.5h-8zM7 16.75a.75.75 0 01.75-.75h6a.75.75 0 010 1.5h-6a.75.75 0 01-.75-.75zM7.75 8a.75.75 0 000 1.5h2a.75.75 0 000-1.5h-2z\"/><path fill-rule=\"evenodd\" d=\"M3 3.75A2.75 2.75 0 015.75 1h7.586c.464 0 .909.184 1.237.513l5.914 5.914c.329.328.513.773.513 1.237V20.25A2.75 2.75 0 0118.25 23H5.75A2.75 2.75 0 013 20.25V3.75zM5.75 2.5c-.69 0-1.25.56-1.25 1.25v16.5c0 .69.56 1.25 1.25 1.25h12.5c.69 0 1.25-.56 1.25-1.25V9h-5.75a.75.75 0 01-.75-.75V2.5H5.75zm8.75 1.06l3.94 3.94H14.5V3.56z\" clip-rule=\"evenodd\"/></g></svg>";

/***/ }),

/***/ "./style/icons/filter-24.svg":
/*!***********************************!*\
  !*** ./style/icons/filter-24.svg ***!
  \***********************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><g fill=\"currentColor\"><path d=\"M3 6.75A.75.75 0 013.75 6h16.5a.75.75 0 010 1.5H3.75A.75.75 0 013 6.75zM6 11.75a.75.75 0 01.75-.75h10.5a.75.75 0 010 1.5H6.75a.75.75 0 01-.75-.75zM9.75 16a.75.75 0 000 1.5h4.5a.75.75 0 000-1.5h-4.5z\"/></g></svg>";

/***/ }),

/***/ "./style/icons/git-merge-24.svg":
/*!**************************************!*\
  !*** ./style/icons/git-merge-24.svg ***!
  \**************************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><path fill=\"currentColor\" fill-rule=\"evenodd\" d=\"M3.5 6.5a3.5 3.5 0 114.096 3.45c.102.41.284.886.551 1.406a11.743 11.743 0 001.81 2.54c1.35 1.456 3.014 2.56 4.635 2.804a3.502 3.502 0 016.908.8 3.5 3.5 0 01-6.928.71c-2.178-.252-4.217-1.677-5.716-3.294A13.885 13.885 0 017.5 13.202v7.548a.75.75 0 01-1.5 0V9.855A3.502 3.502 0 013.5 6.5zm3.5-2a2 2 0 100 4 2 2 0 000-4zm9 13a2 2 0 104 0 2 2 0 00-4 0z\" clip-rule=\"evenodd\"/></svg>";

/***/ }),

/***/ "./style/icons/globe-24.svg":
/*!**********************************!*\
  !*** ./style/icons/globe-24.svg ***!
  \**********************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><path fill=\"currentColor\" fill-rule=\"evenodd\" d=\"M12 1C5.925 1 1 5.925 1 12s4.925 11 11 11 11-4.925 11-11S18.075 1 12 1zm-1.673 1.647A9.506 9.506 0 002.552 11h4.747a16.673 16.673 0 013.028-8.353zm3.346 0A16.673 16.673 0 0116.701 11h4.747a9.506 9.506 0 00-7.775-8.353zM15.196 11A15.149 15.149 0 0012 2.916 15.149 15.149 0 008.804 11h6.392zm-6.427 1.5h6.462A15.16 15.16 0 0112 21.084 15.16 15.16 0 018.769 12.5zm-1.502 0H2.513c.23 4.45 3.525 8.091 7.814 8.853a16.683 16.683 0 01-3.06-8.853zm6.406 8.853a16.683 16.683 0 003.06-8.853h4.754c-.23 4.45-3.525 8.091-7.814 8.853z\" clip-rule=\"evenodd\"/></svg>";

/***/ }),

/***/ "./style/icons/google-sheets-color-24.svg":
/*!************************************************!*\
  !*** ./style/icons/google-sheets-color-24.svg ***!
  \************************************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><path fill=\"#188038\" d=\"M14.266 2l4.984 5h-4.984V2z\"/><path fill=\"#34A853\" d=\"M14.266 7V2H6.109c-.75 0-1.359.61-1.359 1.364v17.272c0 .754.608 1.364 1.36 1.364h11.78c.752 0 1.36-.61 1.36-1.364V7h-4.984z\"/><path fill=\"#FDFFFF\" d=\"M7.469 9.727v6.591h9.062v-6.59H7.47zm3.965 5.455H8.602V13.59h2.832v1.59zm0-2.727H8.602v-1.591h2.832v1.59zm3.964 2.727h-2.832V13.59h2.832v1.59zm0-2.727h-2.832v-1.591h2.832v1.59z\"/></svg>";

/***/ }),

/***/ "./style/icons/monitor-24.svg":
/*!************************************!*\
  !*** ./style/icons/monitor-24.svg ***!
  \************************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><path fill=\"currentColor\" fill-rule=\"evenodd\" d=\"M1 4.75A2.75 2.75 0 013.75 2h16.5A2.75 2.75 0 0123 4.75v10.5A2.75 2.75 0 0120.25 18H12.5v2.5H16a.75.75 0 010 1.5H8a.75.75 0 010-1.5h3V18H3.75A2.75 2.75 0 011 15.25V4.75zM20.25 16.5c.69 0 1.25-.56 1.25-1.25V4.75c0-.69-.56-1.25-1.25-1.25H3.75c-.69 0-1.25.56-1.25 1.25v10.5c0 .69.56 1.25 1.25 1.25h16.5z\" clip-rule=\"evenodd\"/></svg>";

/***/ }),

/***/ "./style/icons/mysql.svg":
/*!*******************************!*\
  !*** ./style/icons/mysql.svg ***!
  \*******************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"64\" height=\"64\" viewBox=\"0 0 25.6 25.6\"><path d=\"M179.076 94.886c-3.568-.1-6.336.268-8.656 1.25-.668.27-1.74.27-1.828 1.116.357.355.4.936.713 1.428.535.893 1.473 2.096 2.32 2.72l2.855 2.053c1.74 1.07 3.703 1.695 5.398 2.766.982.625 1.963 1.428 2.945 2.098.5.357.803.938 1.428 1.16v-.135c-.312-.4-.402-.98-.713-1.428l-1.34-1.293c-1.293-1.74-2.9-3.258-4.64-4.506-1.428-.982-4.55-2.32-5.13-3.97l-.088-.1c.98-.1 2.14-.447 3.078-.715 1.518-.4 2.9-.312 4.46-.713l2.143-.625v-.4c-.803-.803-1.383-1.874-2.23-2.632-2.275-1.963-4.775-3.882-7.363-5.488-1.383-.892-3.168-1.473-4.64-2.23-.537-.268-1.428-.402-1.74-.848-.805-.98-1.25-2.275-1.83-3.436l-3.658-7.763c-.803-1.74-1.295-3.48-2.275-5.086-4.596-7.585-9.594-12.18-17.268-16.687-1.65-.937-3.613-1.34-5.7-1.83l-3.346-.18c-.715-.312-1.428-1.16-2.053-1.562-2.543-1.606-9.102-5.086-10.977-.5-1.205 2.9 1.785 5.755 2.8 7.228.76 1.026 1.74 2.186 2.277 3.346.3.758.4 1.562.713 2.365.713 1.963 1.383 4.15 2.32 5.98.5.937 1.025 1.92 1.65 2.767.357.5.982.714 1.115 1.517-.625.893-.668 2.23-1.025 3.347-1.607 5.042-.982 11.288 1.293 15 .715 1.115 2.4 3.57 4.686 2.632 2.008-.803 1.56-3.346 2.14-5.577.135-.535.045-.892.312-1.25v.1l1.83 3.703c1.383 2.186 3.793 4.462 5.8 5.98 1.07.803 1.918 2.187 3.256 2.677v-.135h-.088c-.268-.4-.67-.58-1.027-.892-.803-.803-1.695-1.785-2.32-2.677-1.873-2.498-3.523-5.265-4.996-8.12-.715-1.383-1.34-2.9-1.918-4.283-.27-.536-.27-1.34-.715-1.606-.67.98-1.65 1.83-2.143 3.034-.848 1.918-.936 4.283-1.248 6.737-.18.045-.1 0-.18.1-1.426-.356-1.918-1.83-2.453-3.078-1.338-3.168-1.562-8.254-.402-11.913.312-.937 1.652-3.882 1.117-4.774-.27-.848-1.16-1.338-1.652-2.008-.58-.848-1.203-1.918-1.605-2.855-1.07-2.5-1.605-5.265-2.766-7.764-.537-1.16-1.473-2.365-2.232-3.435-.848-1.205-1.783-2.053-2.453-3.48-.223-.5-.535-1.294-.178-1.83.088-.357.268-.5.623-.58.58-.5 2.232.134 2.812.4 1.65.67 3.033 1.294 4.416 2.23.625.446 1.295 1.294 2.098 1.518h.938c1.428.312 3.033.1 4.37.5 2.365.76 4.506 1.874 6.426 3.08 5.844 3.703 10.664 8.968 13.92 15.26.535 1.026.758 1.963 1.25 3.034.938 2.187 2.098 4.417 3.033 6.56.938 2.097 1.83 4.24 3.168 5.98.67.937 3.346 1.427 4.55 1.918.893.4 2.275.76 3.08 1.25 1.516.937 3.033 2.008 4.46 3.034.713.534 2.945 1.65 3.078 2.54zm-45.5-38.772a7.09 7.09 0 0 0-1.828.223v.1h.088c.357.714.982 1.205 1.428 1.83l1.027 2.142.088-.1c.625-.446.938-1.16.938-2.23-.268-.312-.312-.625-.535-.937-.268-.446-.848-.67-1.206-1.026z\" transform=\"matrix(.390229 0 0 .38781 -46.300037 -16.856717)\" fill-rule=\"evenodd\" fill=\"#00678c\"/></svg>";

/***/ }),

/***/ "./style/icons/network-alt-24.svg":
/*!****************************************!*\
  !*** ./style/icons/network-alt-24.svg ***!
  \****************************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><g fill=\"currentColor\"><path d=\"M23 12a.75.75 0 00-.232-.543l-5.5-5.25a.75.75 0 00-1.036 1.086L21.164 12l-4.932 4.707a.75.75 0 001.036 1.085l5.5-5.25A.75.75 0 0023 12zM1 12a.75.75 0 01.232-.543l5.5-5.25a.75.75 0 111.036 1.086L2.836 12l4.932 4.707a.75.75 0 01-1.036 1.085l-5.5-5.25A.75.75 0 011 12z\"/><path d=\"M8 11a1 1 0 100 2h.01a1 1 0 100-2H8zM11 12a1 1 0 011-1h.01a1 1 0 110 2H12a1 1 0 01-1-1zM16 11a1 1 0 100 2h.01a1 1 0 100-2H16z\"/></g></svg>";

/***/ }),

/***/ "./style/icons/openai.svg":
/*!********************************!*\
  !*** ./style/icons/openai.svg ***!
  \********************************/
/***/ ((module) => {

module.exports = "<?xml version=\"1.0\" encoding=\"utf-8\"?><!-- Uploaded to: SVG Repo, www.svgrepo.com, Generator: SVG Repo Mixer Tools -->\n<svg fill=\"#000000\" width=\"800px\" height=\"800px\" viewBox=\"0 0 24 24\" role=\"img\" xmlns=\"http://www.w3.org/2000/svg\"><title>OpenAI icon</title><path d=\"M22.2819 9.8211a5.9847 5.9847 0 0 0-.5157-4.9108 6.0462 6.0462 0 0 0-6.5098-2.9A6.0651 6.0651 0 0 0 4.9807 4.1818a5.9847 5.9847 0 0 0-3.9977 2.9 6.0462 6.0462 0 0 0 .7427 7.0966 5.98 5.98 0 0 0 .511 4.9107 6.051 6.051 0 0 0 6.5146 2.9001A5.9847 5.9847 0 0 0 13.2599 24a6.0557 6.0557 0 0 0 5.7718-4.2058 5.9894 5.9894 0 0 0 3.9977-2.9001 6.0557 6.0557 0 0 0-.7475-7.0729zm-9.022 12.6081a4.4755 4.4755 0 0 1-2.8764-1.0408l.1419-.0804 4.7783-2.7582a.7948.7948 0 0 0 .3927-.6813v-6.7369l2.02 1.1686a.071.071 0 0 1 .038.052v5.5826a4.504 4.504 0 0 1-4.4945 4.4944zm-9.6607-4.1254a4.4708 4.4708 0 0 1-.5346-3.0137l.142.0852 4.783 2.7582a.7712.7712 0 0 0 .7806 0l5.8428-3.3685v2.3324a.0804.0804 0 0 1-.0332.0615L9.74 19.9502a4.4992 4.4992 0 0 1-6.1408-1.6464zM2.3408 7.8956a4.485 4.485 0 0 1 2.3655-1.9728V11.6a.7664.7664 0 0 0 .3879.6765l5.8144 3.3543-2.0201 1.1685a.0757.0757 0 0 1-.071 0l-4.8303-2.7865A4.504 4.504 0 0 1 2.3408 7.872zm16.5963 3.8558L13.1038 8.364 15.1192 7.2a.0757.0757 0 0 1 .071 0l4.8303 2.7913a4.4944 4.4944 0 0 1-.6765 8.1042v-5.6772a.79.79 0 0 0-.407-.667zm2.0107-3.0231l-.142-.0852-4.7735-2.7818a.7759.7759 0 0 0-.7854 0L9.409 9.2297V6.8974a.0662.0662 0 0 1 .0284-.0615l4.8303-2.7866a4.4992 4.4992 0 0 1 6.6802 4.66zM8.3065 12.863l-2.02-1.1638a.0804.0804 0 0 1-.038-.0567V6.0742a4.4992 4.4992 0 0 1 7.3757-3.4537l-.142.0805L8.704 5.459a.7948.7948 0 0 0-.3927.6813zm1.0976-2.3654l2.602-1.4998 2.6069 1.4998v2.9994l-2.5974 1.4997-2.6067-1.4997Z\"/></svg>";

/***/ }),

/***/ "./style/icons/outline-24.svg":
/*!************************************!*\
  !*** ./style/icons/outline-24.svg ***!
  \************************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><g fill=\"currentColor\"><path d=\"M6.5 5.75A.75.75 0 017.25 5h.01a.75.75 0 010 1.5h-.01a.75.75 0 01-.75-.75zM7.25 9a.75.75 0 000 1.5h.01a.75.75 0 000-1.5h-.01zM6.5 13.75a.75.75 0 01.75-.75h.01a.75.75 0 010 1.5h-.01a.75.75 0 01-.75-.75zM7.25 17a.75.75 0 000 1.5h.01a.75.75 0 000-1.5h-.01zM9.5 9.75a.75.75 0 01.75-.75h4.5a.75.75 0 010 1.5h-4.5a.75.75 0 01-.75-.75zM10.25 5a.75.75 0 000 1.5h6.5a.75.75 0 000-1.5h-6.5zM9.5 13.75a.75.75 0 01.75-.75h6.5a.75.75 0 010 1.5h-6.5a.75.75 0 01-.75-.75zM10.25 17a.75.75 0 000 1.5h3.5a.75.75 0 000-1.5h-3.5z\"/><path fill-rule=\"evenodd\" d=\"M3 3.75A2.75 2.75 0 015.75 1h12.5A2.75 2.75 0 0121 3.75v16.5A2.75 2.75 0 0118.25 23H5.75A2.75 2.75 0 013 20.25V3.75zM5.75 2.5c-.69 0-1.25.56-1.25 1.25v16.5c0 .69.56 1.25 1.25 1.25h12.5c.69 0 1.25-.56 1.25-1.25V3.75c0-.69-.56-1.25-1.25-1.25H5.75z\" clip-rule=\"evenodd\"/></g></svg>";

/***/ }),

/***/ "./style/icons/random-24.svg":
/*!***********************************!*\
  !*** ./style/icons/random-24.svg ***!
  \***********************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><g fill=\"currentColor\" fill-rule=\"evenodd\" clip-rule=\"evenodd\"><path d=\"M12 9.5a2.5 2.5 0 100 5 2.5 2.5 0 000-5zM11 12a1 1 0 112 0 1 1 0 01-2 0zM5 7.5a2.5 2.5 0 115 0 2.5 2.5 0 01-5 0zm2.5-1a1 1 0 100 2 1 1 0 000-2zM16.5 14a2.5 2.5 0 100 5 2.5 2.5 0 000-5zm-1 2.5a1 1 0 112 0 1 1 0 01-2 0z\"/><path d=\"M4.75 2A2.75 2.75 0 002 4.75v14.5A2.75 2.75 0 004.75 22h14.5A2.75 2.75 0 0022 19.25V4.75A2.75 2.75 0 0019.25 2H4.75zM3.5 4.75c0-.69.56-1.25 1.25-1.25h14.5c.69 0 1.25.56 1.25 1.25v14.5c0 .69-.56 1.25-1.25 1.25H4.75c-.69 0-1.25-.56-1.25-1.25V4.75z\"/></g></svg>";

/***/ }),

/***/ "./style/icons/reddit.svg":
/*!********************************!*\
  !*** ./style/icons/reddit.svg ***!
  \********************************/
/***/ ((module) => {

module.exports = "<svg viewBox=\"0 0 800 800\" xmlns=\"http://www.w3.org/2000/svg\" width=\"2500\" height=\"2500\"><circle cx=\"400\" cy=\"400\" fill=\"#ff4500\" r=\"400\"/><path d=\"M666.8 400c.08 5.48-.6 10.95-2.04 16.24s-3.62 10.36-6.48 15.04c-2.85 4.68-6.35 8.94-10.39 12.65s-8.58 6.83-13.49 9.27c.11 1.46.2 2.93.25 4.4a107.268 107.268 0 0 1 0 8.8c-.05 1.47-.14 2.94-.25 4.4 0 89.6-104.4 162.4-233.2 162.4S168 560.4 168 470.8c-.11-1.46-.2-2.93-.25-4.4a107.268 107.268 0 0 1 0-8.8c.05-1.47.14-2.94.25-4.4a58.438 58.438 0 0 1-31.85-37.28 58.41 58.41 0 0 1 7.8-48.42 58.354 58.354 0 0 1 41.93-25.4 58.4 58.4 0 0 1 46.52 15.5 286.795 286.795 0 0 1 35.89-20.71c12.45-6.02 25.32-11.14 38.51-15.3s26.67-7.35 40.32-9.56 27.45-3.42 41.28-3.63L418 169.6c.33-1.61.98-3.13 1.91-4.49.92-1.35 2.11-2.51 3.48-3.4 1.38-.89 2.92-1.5 4.54-1.8 1.61-.29 3.27-.26 4.87.09l98 19.6c9.89-16.99 30.65-24.27 48.98-17.19s28.81 26.43 24.71 45.65c-4.09 19.22-21.55 32.62-41.17 31.61-19.63-1.01-35.62-16.13-37.72-35.67L440 186l-26 124.8c13.66.29 27.29 1.57 40.77 3.82a284.358 284.358 0 0 1 77.8 24.86A284.412 284.412 0 0 1 568 360a58.345 58.345 0 0 1 29.4-15.21 58.361 58.361 0 0 1 32.95 3.21 58.384 58.384 0 0 1 25.91 20.61A58.384 58.384 0 0 1 666.8 400zm-396.96 55.31c2.02 4.85 4.96 9.26 8.68 12.97 3.71 3.72 8.12 6.66 12.97 8.68A40.049 40.049 0 0 0 306.8 480c16.18 0 30.76-9.75 36.96-24.69 6.19-14.95 2.76-32.15-8.68-43.59s-28.64-14.87-43.59-8.68c-14.94 6.2-24.69 20.78-24.69 36.96 0 5.25 1.03 10.45 3.04 15.31zm229.1 96.02c2.05-2 3.22-4.73 3.26-7.59.04-2.87-1.07-5.63-3.07-7.68s-4.73-3.22-7.59-3.26c-2.87-.04-5.63 1.07-7.94 2.8a131.06 131.06 0 0 1-19.04 11.35 131.53 131.53 0 0 1-20.68 7.99c-7.1 2.07-14.37 3.54-21.72 4.39-7.36.85-14.77 1.07-22.16.67-7.38.33-14.78.03-22.11-.89a129.01 129.01 0 0 1-21.64-4.6c-7.08-2.14-13.95-4.88-20.56-8.18s-12.93-7.16-18.89-11.53c-2.07-1.7-4.7-2.57-7.38-2.44s-5.21 1.26-7.11 3.15c-1.89 1.9-3.02 4.43-3.15 7.11s.74 5.31 2.44 7.38c7.03 5.3 14.5 9.98 22.33 14s16 7.35 24.4 9.97 17.01 4.51 25.74 5.66c8.73 1.14 17.54 1.53 26.33 1.17 8.79.36 17.6-.03 26.33-1.17A153.961 153.961 0 0 0 476.87 564c7.83-4.02 15.3-8.7 22.33-14zm-7.34-68.13c5.42.06 10.8-.99 15.81-3.07 5.01-2.09 9.54-5.17 13.32-9.06s6.72-8.51 8.66-13.58A39.882 39.882 0 0 0 532 441.6c0-16.18-9.75-30.76-24.69-36.96-14.95-6.19-32.15-2.76-43.59 8.68s-14.87 28.64-8.68 43.59c6.2 14.94 20.78 24.69 36.96 24.69z\" fill=\"#fff\"/></svg>";

/***/ }),

/***/ "./style/icons/scissors-24.svg":
/*!*************************************!*\
  !*** ./style/icons/scissors-24.svg ***!
  \*************************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><g fill=\"currentColor\"><path fill-rule=\"evenodd\" d=\"M5.5 2a3.5 3.5 0 101.99 6.38l3.346 3.12-3.346 3.12a3.5 3.5 0 101.023 1.097l3.93-3.664.009-.008 8.31-7.746A.75.75 0 0019.739 3.2l-7.803 7.274-3.424-3.192A3.5 3.5 0 005.5 2zm-2 3.5a2 2 0 114 0 2 2 0 01-4 0zm0 12a2 2 0 114 0 2 2 0 01-4 0z\" clip-rule=\"evenodd\"/><path d=\"M20.763 18.703a.75.75 0 01-1.026 1.095l-5.5-5.15a.75.75 0 011.026-1.095l5.5 5.15z\"/></g></svg>";

/***/ }),

/***/ "./style/icons/settings-16.svg":
/*!*************************************!*\
  !*** ./style/icons/settings-16.svg ***!
  \*************************************/
/***/ ((module) => {

module.exports = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n<svg\n   width=\"16\"\n   height=\"16\"\n   fill=\"none\"\n   viewBox=\"0 0 16 16\"\n   version=\"1.1\"\n   id=\"svg2\"\n   sodipodi:docname=\"settings-16.svg\"\n   inkscape:version=\"1.3 (0e150ed, 2023-07-21)\"\n   xmlns:inkscape=\"http://www.inkscape.org/namespaces/inkscape\"\n   xmlns:sodipodi=\"http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd\"\n   xmlns=\"http://www.w3.org/2000/svg\"\n   xmlns:svg=\"http://www.w3.org/2000/svg\">\n  <defs\n     id=\"defs2\" />\n  <sodipodi:namedview\n     id=\"namedview2\"\n     pagecolor=\"#505050\"\n     bordercolor=\"#eeeeee\"\n     borderopacity=\"1\"\n     inkscape:showpageshadow=\"0\"\n     inkscape:pageopacity=\"0\"\n     inkscape:pagecheckerboard=\"0\"\n     inkscape:deskcolor=\"#505050\"\n     inkscape:zoom=\"34.875\"\n     inkscape:cx=\"8\"\n     inkscape:cy=\"7.9856631\"\n     inkscape:window-width=\"1392\"\n     inkscape:window-height=\"922\"\n     inkscape:window-x=\"0\"\n     inkscape:window-y=\"75\"\n     inkscape:window-maximized=\"0\"\n     inkscape:current-layer=\"svg2\" />\n  <g\n     fill=\"currentColor\"\n     fill-rule=\"evenodd\"\n     clip-rule=\"evenodd\"\n     id=\"g2\">\n    <path\n       d=\"M8 5a3 3 0 100 6 3 3 0 000-6zM6.5 8a1.5 1.5 0 113 0 1.5 1.5 0 01-3 0z\"\n       id=\"path1\" />\n    <path\n       d=\"M7.5 0a1.75 1.75 0 00-1.75 1.75v.15c-.16.06-.318.125-.472.196l-.106-.106a1.75 1.75 0 00-2.475 0l-.707.707a1.75 1.75 0 000 2.475l.106.106a6.46 6.46 0 00-.196.472h-.15A1.75 1.75 0 000 7.5v1c0 .966.784 1.75 1.75 1.75h.15c.06.16.125.318.196.472l-.106.107a1.75 1.75 0 000 2.474l.707.708a1.75 1.75 0 002.475 0l.106-.107c.154.071.312.137.472.196v.15c0 .966.784 1.75 1.75 1.75h1a1.75 1.75 0 001.75-1.75v-.15c.16-.06.318-.125.472-.196l.106.107a1.75 1.75 0 002.475 0l.707-.707a1.75 1.75 0 000-2.475l-.106-.107c.071-.154.137-.311.196-.472h.15A1.75 1.75 0 0016 8.5v-1a1.75 1.75 0 00-1.75-1.75h-.15a6.455 6.455 0 00-.196-.472l.106-.106a1.75 1.75 0 000-2.475l-.707-.707a1.75 1.75 0 00-2.475 0l-.106.106a6.46 6.46 0 00-.472-.196v-.15A1.75 1.75 0 008.5 0h-1zm-.25 1.75a.25.25 0 01.25-.25h1a.25.25 0 01.25.25v.698c0 .339.227.636.555.724.42.113.817.28 1.186.492a.75.75 0 00.905-.12l.493-.494a.25.25 0 01.354 0l.707.708a.25.25 0 010 .353l-.494.494a.75.75 0 00-.12.904c.213.369.38.767.492 1.186a.75.75 0 00.724.555h.698a.25.25 0 01.25.25v1a.25.25 0 01-.25.25h-.698a.75.75 0 00-.724.555c-.113.42-.28.817-.492 1.186a.75.75 0 00.12.905l.494.493a.25.25 0 010 .354l-.707.707a.25.25 0 01-.354 0l-.494-.494a.75.75 0 00-.904-.12 4.966 4.966 0 01-1.186.492.75.75 0 00-.555.724v.698a.25.25 0 01-.25.25h-1a.25.25 0 01-.25-.25v-.698a.75.75 0 00-.555-.724 4.966 4.966 0 01-1.186-.491.75.75 0 00-.904.12l-.494.493a.25.25 0 01-.354 0l-.707-.707a.25.25 0 010-.354l.494-.493a.75.75 0 00.12-.905 4.966 4.966 0 01-.492-1.186.75.75 0 00-.724-.555H1.75a.25.25 0 01-.25-.25v-1a.25.25 0 01.25-.25h.698a.75.75 0 00.724-.555c.113-.42.28-.817.491-1.186a.75.75 0 00-.12-.904L3.05 4.11a.25.25 0 010-.353l.707-.708a.25.25 0 01.354 0l.493.494c.24.24.611.289.905.12a4.965 4.965 0 011.186-.492.75.75 0 00.555-.724V1.75z\"\n       id=\"path2\" />\n  </g>\n</svg>\n";

/***/ }),

/***/ "./style/icons/sort-desc-24.svg":
/*!**************************************!*\
  !*** ./style/icons/sort-desc-24.svg ***!
  \**************************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><g fill=\"currentColor\"><path d=\"M3 5.75A.75.75 0 013.75 5h16.5a.75.75 0 010 1.5H3.75A.75.75 0 013 5.75zM3.75 9a.75.75 0 000 1.5h9.5a.75.75 0 000-1.5h-9.5zM16.963 20.443a.747.747 0 00.817-.163l4-4a.75.75 0 10-1.06-1.06L18 17.94V9.75a.75.75 0 00-1.5 0v8.19l-2.72-2.72a.75.75 0 10-1.06 1.06l4 4a.748.748 0 00.243.163zM3.75 13a.75.75 0 000 1.5h5.5a.75.75 0 000-1.5h-5.5zM3 17.75a.75.75 0 01.75-.75h3.5a.75.75 0 010 1.5h-3.5a.75.75 0 01-.75-.75z\"/></g></svg>";

/***/ }),

/***/ "./style/icons/type-24.svg":
/*!*********************************!*\
  !*** ./style/icons/type-24.svg ***!
  \*********************************/
/***/ ((module) => {

module.exports = "<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"24\" height=\"24\" fill=\"none\" viewBox=\"0 0 24 24\"><path fill=\"currentColor\" d=\"M3 3.75A.75.75 0 013.75 3h16a.75.75 0 01.75.75v2.5a.75.75 0 01-1.5 0V4.5h-6.5v15h2a.75.75 0 010 1.5H9a.75.75 0 010-1.5h2v-15H4.5v1.75a.75.75 0 01-1.5 0v-2.5z\"/></svg>";

/***/ })

}]);
//# sourceMappingURL=lib_index_js.8524d2449200481bcffc.js.map